
local pad_x_max = 24 
local pad_y_max = 12 

local vb = renoise.ViewBuilder()

updateSlots = {}


function populatePatPolyN() 

  MW.timer_pos2 = {}
  
  local scale_no = UI.scales_pu.value
  local key_no = UI.keys_pu.value
  
  local tx,tt  
  local scale
  if Scales.on == 1 then
    scale = scale_key (Scales.forms[scale_no], key_no - 1)        
  else
    scale = scale_key (Scales.forms[1], 1)
  end
   
  local pat_len = renoise.song().selected_pattern.number_of_lines
  local ln = 1
  local j = 1

  while ln <= MW.seq_length and j <= pat_len do 

    local pr_row                    = vb:row{}
    UI.editor_bts[j]                = {}
    UI.editor_bts[ln].patN_notes_ix = {}
      
    local note = {}
    local note_tmp
      
    for k=1,12 do
      note_tmp = getNote(k, j)   
      if note_tmp < 120 then 
        table.insert(note, note_tmp)
      end
    end  
    
    if #note > 0 then
      
      local oct = 0
      local ix = 1
       
            
      local oct_en = UI.oct_end.value - UI.oct_st.value
      for i=1,#scale*oct_en do
      
        local note_but = scale[ix] + (oct + UI.oct_st.value) * 12
        
        tx = ""
        if Scales.on == 2 and member (scale[ix] , scale_key (Scales.forms[scale_no], key_no - 1))  then
          tx = "."
        end
        
        tt = Scales.keys[scale[ix]+1] .. Scales.keys_dash[scale[ix]+1] .. oct + UI.oct_st.value 
        
        local col = {1, 1, 1}
        for k=1,#note do
          if  (note[k] == note_but) then
            col = {255, 255, 255} 
            
            table.insert(UI.editor_bts[ln].patN_notes_ix, i)
            break
          end 
        end

        local ln2 = ln   
        local j2 = j
        
        UI.vel_knob_pos[ln] = j
        
        UI.editor_bts[ln][i] = vb:button {
          tooltip = tt,
          text = tx,
          color =  col,
          notifier = function()
          
            local first_empty_col = 0
            for k=1,12 do
              local note = getNote(k, j2)  
              if note >= 120 or note == note_but then
                first_empty_col = k
                break
              end
            end          
          
            local note_col = {} 
            for k=1,12 do
              local note = getNote(k, j2) 
              if  note == note_but then
                note_col[#note_col+1] = k              
              end
            end
            
            if (UI.editor_bts[ln2][i].color[1] == 1 or UI.editor_bts[ln2][i].color[1] == 64 or UI.editor_bts[ln2][i].color[1] == 32) and first_empty_col > 0 then
              UI.editor_bts[ln2][i].color = {255, 255, 255}    
             
              
              table.insert(UI.editor_bts[ln2].patN_notes_ix, i)
              
              fillNote(note_but, first_empty_col, j2)
                            
            elseif UI.editor_bts[ln2][i].color[1] == 255 then 
              for k=1,#note_col do
                
                removeElmFromTb(i, UI.editor_bts[ln2].patN_notes_ix)         
               
                UI.editor_bts[ln2][i].color = {1, 1, 1}
              
                fillNote(121, note_col[k], j2)   
              end         
            end
          end
        }

        if ix < #scale then
          ix = ix + 1
        else
          ix = 1
          oct = oct + 1
        end      

        pr_row:add_child( UI.editor_bts[ln][i])        
      end
      UI.editor_rows[ln] = pr_row      
      ln = ln + 1      
    end    

    MW.timer_pos2[j] = ln - 1
    
    j = j+1
  end
  
  for i=ln,MW.seq_length do 
    UI.editor_rows[i] = vb:row{}   
  end  
   
  UI.last_used_editor_was_stepN = true
end


function populatePatPoly()  
  
  local scale_no = UI.scales_pu.value 
  local key_no = UI.keys_pu.value
 
  MW.phr.lpb = setLPB()
  
  local tx,tt  
  local scale
  if Scales.on == 1 then
    scale = scale_key (Scales.forms[scale_no], key_no - 1)        
  else
    scale = scale_key (Scales.forms[1], 1)
  end
  
  
  for j=1,MW.seq_length do
   
    local ix   = 1
    local oct  = 0    
    local note = {}
    local note_tmp
    
    UI.editor_bts[j]              = {}
    UI.editor_bts[j].pat_notes_ix = {}
    
    local bg_col = {1, 1, 1}
    if member(j,MW.phr.lpb) then
      bg_col = {32, 32, 32}
    end
  
    local pr_row = vb:row{}          
      
    for k=1,12 do
      note_tmp = getNote(k, j)   
      if note_tmp < 120 then 
        note[#note+1] = note_tmp   
      end
    end         
       
    local oct_en = UI.oct_end.value - UI.oct_st.value
    for i=1,#scale*oct_en do
      
      local note_but = scale[ix] + (oct + UI.oct_st.value) * 12
      
      tx = ""
      if Scales.on == 2 and member (scale[ix] , scale_key (Scales.forms[scale_no], key_no - 1))  then
        tx = "."
      end
      
      tt = Scales.keys[scale[ix]+1] .. Scales.keys_dash[scale[ix]+1] .. oct + UI.oct_st.value 
            
      local col = bg_col
      for k=1,#note do
        if note[k] == note_but then
          col = {255, 255, 255} 
          
          table.insert(UI.editor_bts[j].pat_notes_ix, i)
          break
        end 
      end

           
      UI.editor_bts[j][i] = vb:button {
        tooltip = tt,
        text = tx,
        color =  col,
        notifier = function()
          
          local bg_col = {1, 1, 1}
          if member(j,MW.phr.lpb) then
            bg_col = {32, 32, 32}
          end
          
          local first_empty_col = 0
          for k=1,12 do
            local note = getNote(k, j)  
            if note >= 120 or note == note_but then
              first_empty_col = k
              break
            end
          end          
          
          local note_col = {} 
          for k=1,12 do
            local note = getNote(k, j) 
            if note == note_but then
              note_col[#note_col+1] = k              
            end
          end
            
          
          if (UI.editor_bts[j][i].color[1] == 1 or UI.editor_bts[j][i].color[1] == 64 or UI.editor_bts[j][i].color[1] == 32) and first_empty_col > 0 then
            UI.editor_bts[j][i].color = {255, 255, 255}    
            
            table.insert(UI.editor_bts[j].pat_notes_ix, i)
            
            fillNote(note_but, first_empty_col, j)

          elseif UI.editor_bts[j][i].color[1] == 255 then 
            for k=1,#note_col do
              UI.editor_bts[j][i].color = bg_col
              
              removeElmFromTb(i,UI.editor_bts[j].pat_notes_ix)
              
              fillNote(121, note_col[k], j)   
            end         
          end      
        end
      }

      if ix < #scale then
        ix = ix + 1
      else
        ix = 1
        oct = oct + 1
      end      

      pr_row:add_child( UI.editor_bts[j][i])
    end
    UI.editor_rows[j] = pr_row
  end
  
  UI.last_used_editor_was_stepN = false
end


function populatePatN()  

  MW.timer_pos2 = {}
  
  local tx,tt  
  
  local scale
  
  local scale_no = UI.scales_pu.value
  local key_no = UI.keys_pu.value
  
  if Scales.on == 1 then
    scale = scale_key (Scales.forms[scale_no], key_no - 1)       
  else
    scale = scale_key (Scales.forms[1], 1)
  end 
  
  local pat_len = renoise.song().selected_pattern.number_of_lines
  
  local ln = 1
  local j = 1

  MW.timer_pos2 = {}
  
  while ln <= MW.seq_length and j <= pat_len do  

    local pr_row                    = vb:row{}
    UI.editor_bts[ln]               = {}
    UI.editor_bts[ln].patN_notes_ix = {}
      
    local note = getNote(MW.phr.col, j)
    
    if note < 120 then

      local oct = 0
      local ix = 1
       
      local oct_en = UI.oct_end.value - UI.oct_st.value
      for i=1,#scale*oct_en do
        local col 
      
        local note_but = scale[ix] + (oct + UI.oct_st.value) * 12
        if  note == note_but then
          col = {255, 255, 255} 
          UI.editor_bts[ln].patN_notes_ix = {i}
        else
          col = { 1, 1, 1 }
        end         
        
        tx = ""
        if Scales.on == 2 and member (scale[ix] , scale_key (Scales.forms[scale_no], key_no - 1)) then
          tx = "."
        end
        
        tt = Scales.keys[scale[ix]+1] .. Scales.keys_dash[scale[ix]+1] .. oct + UI.oct_st.value   

        local ln2 = ln   
        local j2 = j   
        
        UI.vel_knob_pos[ln] = j
        
        UI.editor_bts[ln][i] = vb:button {
          tooltip = tt,
          text = tx,
          color =  col,
          notifier = function()          
    
            if UI.editor_bts[ln2][i].color[1] ~= 255 then
          
              for k=1,#UI.editor_bts[ln2] do
                UI.editor_bts[ln2][k].color = {1, 1, 1}
              end
          
              UI.editor_bts[ln2][i].color = {255, 255, 255}
              
              UI.editor_bts[ln2].patN_notes_ix = {i} 
              
              fillNote(note_but, MW.phr.col, j2)
            else
              UI.editor_bts[ln2][i].color = {1, 1, 1}
              
              UI.editor_bts[ln2].patN_notes_ix = {}
              
              fillNote(121, MW.phr.col, j2)
            end
          end
        }

        if ix < #scale then
          ix = ix + 1
        else
          ix = 1
          oct = oct + 1
        end      

        pr_row:add_child( UI.editor_bts[ln2][i])
      end
      UI.editor_rows[ln] = pr_row      
      ln = ln + 1     
    end      
    MW.timer_pos2[j] = ln - 1
    
    j = j + 1
    UI.editor_rows[j] = pr_row
  end

  for i=ln,MW.seq_length do 
    UI.editor_rows[i] = vb:row{}   
  end
  
  UI.last_used_editor_was_stepN = true
end


function populatePat()  

  local scale_no = UI.scales_pu.value
  local key_no = UI.keys_pu.value

  UI.editor_bts = {}
  UI.editor_rows = {}
  
  MW.phr.lpb = setLPB()
    
  local tx,tt  
  local scale
  if Scales.on == 1 then
    scale = scale_key (Scales.forms[scale_no], key_no - 1)        
  else
    scale = scale_key (Scales.forms[1], 1)
  end 
    
  for j=1,MW.seq_length do 
  
    UI.editor_bts[j]              = {}
    UI.editor_bts[j].pat_notes_ix = {}
    
    local bg_col = {1, 1, 1}
    if member(j,MW.phr.lpb) then
      bg_col = {32, 32, 32}
    end
    
    local pr_row = vb:row{}    
      
    local note = getNote(MW.phr.col, j)
       
    local oct = 0
    local ix = 1
       
    local oct_en = UI.oct_end.value - UI.oct_st.value
    for i=1,#scale*oct_en do
      local col 
      
      tx = ""
      if Scales.on == 2 and member (scale[ix] , scale_key (Scales.forms[scale_no], key_no - 1)) then
        tx = "."
      end
      
      tt = Scales.keys[scale[ix]+1] .. Scales.keys_dash[scale[ix]+1] .. oct + UI.oct_st.value 
      
      local note_but = scale[ix] + (oct + UI.oct_st.value) * 12
      if note == note_but then
        col = {255, 255, 255} 
        
        UI.editor_bts[j].pat_notes_ix = {i}
      else
        col = bg_col 
      end 
    
      UI.editor_bts[j][i] = vb:button {
        tooltip = tt,
        text = tx,
        color =  col,
        notifier = function()
          
          local bg_col = {1, 1, 1}
          if member(j,MW.phr.lpb) then
            bg_col = {32, 32, 32}
          end
    
          if UI.editor_bts[j][i].color[1] ~= 255 then
          
            for k=1,#UI.editor_bts[j] do
              UI.editor_bts[j][k].color = bg_col
            end
          
            UI.editor_bts[j].pat_notes_ix = {i}
            
            UI.editor_bts[j][i].color = {255, 255, 255}
            
            fillNote(note_but, MW.phr.col, j)
          else
            UI.editor_bts[j].pat_notes_ix = {}
            
            UI.editor_bts[j][i].color = bg_col
            
            fillNote(121, MW.phr.col, j)
          end
        end
      }

      if ix < #scale then
        ix = ix + 1
      else
        ix = 1
        oct = oct + 1
      end      

      pr_row:add_child( UI.editor_bts[j][i])
    end
    UI.editor_rows[j] = pr_row
  end
  
  UI.last_used_editor_was_stepN = false
end


local fillVbox = {suspend = false}

fillVbox.funUnsuspended = function(...)  
  if arg[1] then  
    fill(MW.phr.col,arg[1]) 
  else
    fill(MW.phr.col) 
  end
end


fillVbox.fun = function(...)  
  if not fillVbox.suspend then fillVbox.funUnsuspended(arg) end  
end


function populateVboxChrd()  

  local scale_no = UI.scales_pu.value
  local key_no = UI.keys_pu.value
  
  local tx,tt  
  local scale
  if Scales.on == 1 then
    scale = scale_key (Scales.forms[scale_no], key_no - 1)        
  else
    scale = scale_key (Scales.forms[1], 1)
  end 
  
  fillVbox.suspend = false 
  
  for j=1,MW.seq_length do  
  
    local pr_row          = vb:row{}
    local oct_add         = 0        
    
    UI.editor_bts[j] = {}
    UI.editor_bts[j].notes = {}
    UI.editor_bts[j].chrd_notes = {}
    UI.editor_bts[j].notes_ix = {} 

    local ix = 1
      
    local oct_en = UI.oct_end.value - UI.oct_st.value    
    
    local chrd = CHptr.notes[j]
    
    seekChd(chrd,j) 
    
    for i=1,#scale*oct_en do      
      
      tx = ""
      if Scales.on == 2 and member (scale[ix] , scale_key (Scales.forms[scale_no], key_no - 1)) then
        tx = "."
      end
                     
      local col          
      
      local oct        = UI.oct_st.value + oct_add  
      local note       = CHptr.notes[j][1]   -- CHNptr.note[j] + CHNptr.oct[j] * 12
      local note_norm  = scale[ix] 
      local note_full  = note_norm + oct * 12
      
      UI.editor_bts[j][i] = {}     
      
      UI.editor_bts[j].notes[note_full] = i
      UI.editor_bts[j].chrd_notes[i] = note_full
      
      tt = Scales.keys[scale[ix]+1] .. Scales.keys_dash[scale[ix]+1] .. oct  
      
      if  member(note_full, chrd) and CHptr.len[j] > 0 then
        table.insert(UI.editor_bts[j].notes_ix,i)
        
        col = {255, 255, 255}                 
      else
        col = { 1, 1, 1 }
      end
      
      local update 
      update = function()      
        if #UI.editor_bts[j].notes_ix == 0 then 
          CHptr.len [j] = 0
          return 
        end
        
        CHptr.notes[j]            = unique(CHptr.notes[j]) 
        UI.editor_bts[j].notes_ix = unique(UI.editor_bts[j].notes_ix)               
        
        table.sort(CHptr.notes[j])  
                print('edit 581  ##CHptr.notes[j] ' .. #CHptr.notes[j])
        seekChd(CHptr.notes[j],j)         
        UI.chrd_key_vbs  [j].value = UI.chord_keys  [j]
        UI.chrd_form_vbs [j].value = UI.chord_forms [j]
        UI.chrd_scale_vbs[j].value = UI.chord_scales[j] 
                              
        local note, oct      = oct0(CHptr.notes[j][1]) 
        UI.note_vbs[j].value = note
        UI.oct_vbs [j].value = oct     
         
        CHptr.len[j] = UI.len_vbs[j].value                             
      end
           
           
      UI.editor_bts[j][i] = vb:button {
        tooltip = tt,
        text = tx,
        color =  col,
        notifier = function()       
          
          fillVbox.suspend = true  
                   
          local key,loc = retKeyIx (UI.editor_bts[j].notes_ix, i)  
          
          if loc == i then 
            UI.editor_bts[j][i].color = {1, 1, 1}  
            UI.editor_bts[j].notes_ix[key] = nil    
            
            if #CHptr.notes[j] > 1 then
              removeElmFromTb(note_full, CHptr.notes[j])
            end
             
            update()                      
                        
            if #UI.editor_bts[j].notes_ix == 0 then     
              CHptr.len[j] = 0       
              fillVbox.funUnsuspended({pos = true})  
            else
              fillVbox.funUnsuspended({st = j, en = j, pos = false})
            end
            fillVbox.suspend = false   
            return
          end
          
          UI.editor_bts[j][i].color = {255, 255, 255}                      
          
          if CHptr.len[j] == 0 then 
            CHptr.len[j] = 1
            UI.len_vbs[j].value = 1
            
            CHptr.notes[j] = {}
            UI.editor_bts[j].notes_ix = {}
          else
            CHptr.len[j] = UI.len_vbs[j].value   
          end          
          
          table.insert(UI.editor_bts[j].notes_ix, i) 
          table.insert(CHptr.notes[j], note_full)  
          
          update()  
          
          if loc then
            fillVbox.funUnsuspended({st = j,en = j,pos = false})     
          else
            fillVbox.funUnsuspended({pos = true})
          end
          
          fillVbox.suspend = false     
        end
      }      
      
      if ix < #scale then
        ix = ix + 1
      else
        ix = 1
        oct_add = oct_add + 1
      end        

      pr_row:add_child( UI.editor_bts[j][i])
    end
    UI.editor_rows[j] = pr_row
  end
end


local function getTonnetzNotes(j) 
  
  if CHptr.len[j] == 0 then return end  
   
  local pos_xy   
  local notes_by_oct = {}   
  
  UI.editor_bts[j].notes_pos = {}
  
  for _,ch_note in ipairs(CHptr.notes[j]) do
    local nn, oct = oct0(ch_note)
    
    if notes_by_oct[oct] then   
      table.insert(notes_by_oct[oct],ch_note)
    else
      notes_by_oct[oct] = {}   
      table.insert(notes_by_oct[oct],ch_note)
    end
  end   
  
  local fun = function(notes)
    
    local found_or_first  = true
    local notes_not_found = {}
    
    for _,ch_note in pairs(notes) do
      local nn, oct = oct0(ch_note)   

      if oct >= UI.oct_st.value and oct < UI.oct_end.value then
       
        for k,v in pairs (Tonnetz.pos) do  
                
          if Tonnetz.oct1[v.y][v.x] == nn then  

            if #pos_xy > 0 then
              for _,vv in ipairs(pos_xy) do 
              
                if oct ~= vv.oct then 
                  found_or_first = true
                  break  
                end
              
                local dif_x = math.abs(v.x - vv.x)
                local dif_y = math.abs(v.y - vv.y) 
              
                if dif_x <= 1 and dif_y <= 1 then  
                  found_or_first = true
                  break
                else
                  found_or_first = false
                end
              end
            end                              
          
            if found_or_first then                      
            
              table.insert(pos_xy,{x = v.x, y = v.y, oct = oct})
            
              local oct_offset = (oct - UI.oct_st.value)*12 
              UI.editor_bts[j].tonnetz[v.y][v.x + oct_offset].color = {255,255,255}         
            
              table.insert(UI.editor_bts[j].notes_pos,
                             { note = ch_note, 
                               x = v.x+oct_offset, 
                               y = v.y, 
                               oct = oct - UI.oct_st.value, 
                               pad_x = pad_x_max/2, 
                               pad_y = pad_y_max/2 })      
              break
            end          
          end     
        
          if k == #Tonnetz.pos then 
            table.insert(notes_not_found, ch_note)
          end                
        end
      end
    end           
    return notes_not_found
  end
    
  for _, notes in pairs(notes_by_oct) do    
    pos_xy = {}  
    
    local notes_not_found = fun(notes)
    if #notes_not_found then
      fun(notes_not_found)
    end
  end  
end


function findTonnetzChord(j)
  
  Tonnetz.suspend = true
            
  if #UI.editor_bts[j].notes_pos > 2 then
    local xy = map(UI.editor_bts[j].notes_pos, function(v) return {v.x % 12,v.y} end)   
              
    table.sort(xy, function(a,b) return a[2]<b[2] end) 
              
    local n = xy[1][2]
    for _,v in ipairs(xy) do
      v[2] = v[2] - n    
    end 
               
    table.sort(xy, function(a,b) return a[1]<b[1] end)
              
    local n = xy[1][1]
    for _,v in ipairs(xy) do
      v[1] = v[1] - n   
    end              
              
    local tb = {}             
    for _,v in ipairs(xy) do
      local str = v[1] .. v[2]
      table.insert(tb,str)            
    end
        
    local notes = map(CHptr.notes[j], function(v) return v%12 end) 
    
    table.sort(notes)
              
    local key = table.concat(tb, '') .. ';' .. table.concat(notes,',')  
              
    if Tonnetz.chords_pos_str[key] then 
      
      local tix = Tonnetz.chords_ix[Tonnetz.chords_pos_str[key].name]
      UI.form_tonnetz[j]                = tix
      UI.chrd_form_tonnetz_vbs[j].value = tix

      Tonnetz.chord   = Tonnetz.chords_pos_str[key].name      
      Tonnetz.suspend = false      
      return         
    end
  end
  
  UI.form_tonnetz[j]                = 12
  UI.chrd_form_tonnetz_vbs[j].value = #Tonnetz.chords_names
  
  Tonnetz.chord   = 'Other'  
  Tonnetz.suspend = false
  
end
 
 
function populateTonnetz()  
  
  UI.tonnetz_force_sk_chb = {}
   
  local oct_range = UI.oct_end.value - UI.oct_st.value 
  
  if oct_range <= 0 then 
    for j=1,MW.seq_length do 
      local row = vb:row{}
      UI.editor_rows[j] = row      
    end
    return 
  end 
        
  local scale_no = UI.scales_pu.value
  local key_no = UI.keys_pu.value
  
  local tx,tt  
  local scale = scale_key (Scales.forms[scale_no], key_no - 1)  
  
  fillVbox.suspend = false   
  
  local col_notes = {0,3,11,2,10,1}  
  
  for j=1,MW.seq_length do 
    
    seekChd(CHptr.notes[j],j) 
  --  UI.chrd_key_vbs  [j].value = UI.chord_keys  [j]
  --  UI.chrd_form_vbs [j].value = UI.chord_forms [j]
  --  UI.chrd_scale_vbs[j].value = UI.chord_scales[j]
          
    local tonnetz_col  = vb:column{}
    local tonnetz_rows = {}          
    
    UI.editor_bts[j]           = {}
    UI.editor_bts[j].tonnetz   = {} 
    UI.editor_bts[j].notes_pos = {}         

    for y=1,6 do 

     local oct_add = 0  
     
     tonnetz_rows[y] = vb:row{ spacing = 12 }
       
     if y%2 == 0 then
       local offset = 
         vb:text {
           width = 4,
           text = ''
         }         
       tonnetz_rows[y]:add_child(offset)
     end  
    
      UI.editor_bts[j].tonnetz[y] = {}  
      
      local add = 0
      if oct_range > 1 then
        add = oct_range - 1
      end

      for x=0,11*oct_range+add do      
      
        local tnote = (col_notes[y]+x * 7) % 12

        local bitmap_name, tx = '', ''
        if UI.scales_pu.value > 1 then
          if member (tnote, scale) then
            tx = '.'
            bitmap_name = 'bt_dim_' .. tnote .. '.bmp'
          else
            tx = ''
            bitmap_name = 'bt.bmp'
          end
        else
          tx = tostring(tnote)
          bitmap_name = 'bt_dim_' .. tnote .. '.bmp'
        end
        
        if x%12 == 0 and x ~= 0 then
          local offset = 
            vb:text {
             width = 4,
             text = ''
           } 
          tonnetz_rows[y]:add_child(offset)
        end 
                     
        local col = {1,1,1}          
   
        local oct_add = math.floor(x/12)   
        local oct     = UI.oct_st.value + oct_add  
        local nf      = tnote + (oct_add + UI.oct_st.value) * 12   
              
        UI.editor_bts[j].tonnetz[y][x] = {}       

        tt = Scales.keys[tnote+1] .. Scales.keys_dash[tnote+1] .. oct         
         
        local update 
        update = function()  
          
          if #UI.editor_bts[j].notes_pos == 0 then 
            CHptr.len [j] = 0
            return 
          end
                              
          local tb = {}          
          local check   
          check = function(v2) 
            for k,v in pairs(tb) do 
              if v.note == v2.note then
                return false
              end
            end
            return true      
          end
    
          for _,v in pairs(UI.editor_bts[j].notes_pos) do 
            if check(v) then 
              table.insert(tb,v)      
            end
          end

          UI.editor_bts[j].notes_pos = tb 
             
          local chrd_notes = map(UI.editor_bts[j].notes_pos, function (v) return v.note end)
          table.sort(chrd_notes) 
          
          CHptr.notes[j] = chrd_notes  
               
          seekChd(chrd_notes,j)  
          UI.chrd_key_vbs  [j].value = UI.chord_keys  [j]
          UI.chrd_form_vbs [j].value = UI.chord_forms [j]
          UI.chrd_scale_vbs[j].value = UI.chord_scales[j] 
        
          CHptr.len[j] = UI.len_vbs[j].value 
          
          local note,oct       = oct0(chrd_notes[1])  
          UI.oct_vbs[j].value  = oct
          UI.note_vbs[j].value = note      
        end

        
        UI.editor_bts[j].tonnetz[y][x] = vb:button {
          tooltip = tt,
          text = tx,
          color =  col,
          bitmap = bitmap_name,
          notifier = function() 
            fillVbox.suspend = true 
                      
            local empty = true
            
            for k,v in pairs(UI.editor_bts[j].notes_pos) do  
                          
              if nf == v.note and v.y ~= y and v.x ~= x then
              
                UI.editor_bts[j].tonnetz[v.y][v.x].color = {1, 1, 1}  
                UI.editor_bts[j].tonnetz[y][x].color   = {255, 255, 255}  
                
                v.y = y
                v.x = x   
                
                update()  
                findTonnetzChord(j)
                
                return             
              elseif nf == v.note  then
              
                UI.editor_bts[j].notes_pos[k]        = nil   
                UI.editor_bts[j].tonnetz[y][x].color = {1, 1, 1}  
                
                update()                  
                findTonnetzChord(j)
                
                if #UI.editor_bts[j].notes_pos == 0 then 
                  fillVbox.funUnsuspended({st = 1, pos = true})
                else
                  fillVbox.funUnsuspended({st = j, en = j, pos = false})
                end
                
                fillVbox.suspend = false 
                return    
              end
              empty = false
            end                          
                        
            UI.editor_bts[j].tonnetz[y][x].color = {255, 255, 255} 
            table.insert(UI.editor_bts[j].notes_pos,
                          { note = nf, 
                            x = x, 
                            y = y, 
                            oct = oct_add, 
                            pad_x = round(UI.pads[j].value.x), 
                            pad_y = round(UI.pads[j].value.y) }) 
            update()    
 
            if empty then 
              CHptr.len [j] = UI.len_vbs[j].value
              fillVbox.funUnsuspended({pos = true})
            else
              fillVbox.funUnsuspended({st = j,en = j,pos = false})  
            end
            
            findTonnetzChord(j) 
            
            fillVbox.suspend = false            
          end
        }             
        tonnetz_rows[y]:add_child(UI.editor_bts[j].tonnetz[y][x])
      end
      
      tonnetz_col:add_child(tonnetz_rows[y])  
    end
                
    getTonnetzNotes(j)
    
    UI.editor_rows[j] = tonnetz_col         
  end  
end


function populateVbox() 
  
  assignNoteTbs(MW.phr.col) 
  
  local scale_no = UI.scales_pu.value
  local key_no = UI.keys_pu.value
  
  local tx,tt  
  local scale
  if Scales.on == 1 then
    scale = scale_key (Scales.forms[scale_no], key_no - 1)        
  else
    scale = scale_key (Scales.forms[1], 1)
  end 
  
  fillVbox.suspend = false
      
  for j=1,MW.seq_length do  
    
    local oct_add = 0
    
    local pr_row = vb:row{}
    UI.editor_bts[j]          = {}
    UI.editor_bts[j].notes    = {}
    UI.editor_bts[j].note_ix = nil
    
    local ix = 1
      
    local oct_en = UI.oct_end.value - UI.oct_st.value
    
    for i=1,#scale*oct_en do      
      
      tx = ""
      if Scales.on == 2 and member (scale[ix] , scale_key (Scales.forms[scale_no], key_no - 1)) then
        tx = "."
      end
                     
      local col          
      
      local oct        = UI.oct_st.value + oct_add     
      local note       = Nptr.note[j] + Nptr.oct[j] * 12  
      local note_norm  = scale[ix] 
      local note_full  = note_norm + oct * 12  
      
      UI.editor_bts[j][i]     = {}       
      UI.editor_bts[j].notes[note_full] = i
      
      tt = Scales.keys[scale[ix]+1] .. Scales.keys_dash[scale[ix]+1] .. oct        
       
      if  note ==  note_full and Nptr.len[j] > 0 then  
        col = {255, 255, 255} 
        UI.editor_bts[j].note_ix = i
      else
        col = { 1, 1, 1 }
      end            
           
      UI.editor_bts[j][i] = vb:button {
        tooltip = tt,
        text = tx,
        color =  col,
        notifier = function()          

          local loc = UI.editor_bts[j].note_ix
          
          if loc == i then 
            UI.editor_bts[j][i].color = {1, 1, 1}            
            UI.editor_bts[j].note_ix = nil
            
            Nptr.len[j] = 0

            fill(MW.phr.col,{st = j, add_off = true, pos = true})  
            return
          elseif loc then 
            UI.editor_bts[j][loc].color = {1, 1, 1}
          end

          if Nptr.len[j] == 0 then 
            UI.editor_bts[j].note_ix = i
            
            UI.note_vbs[j].value = note_norm
            UI.oct_vbs[j].value = oct            
            
            if UI.len_vbs[j].value > 0 then
              Nptr.len[j] = UI.len_vbs[j].value
            else            
              Nptr.len[j] = UI.len_vbs[j].value 
            end
            
            UI.editor_bts[j][i].color = {255, 255, 255}
            
            fill(MW.phr.col,{st = 1, add_off = true, pos = true})
            return
          end

          UI.editor_bts[j][i].color = {255, 255, 255}
           
          Nptr.note[j] = note_norm    
          Nptr.oct [j] = oct      

          UI.editor_bts[j].note_ix = i
          
          if UI.note_vbs[j].value ~= note_norm then      
            UI.note_vbs[j].value = note_norm
          end
        end
      }      
      
      if ix < #scale then
        ix = ix + 1
      else
        ix = 1
        oct_add = oct_add + 1
      end        

      pr_row:add_child( UI.editor_bts[j][i])
    end
    UI.editor_rows[j] = pr_row
  end
end


function populate_pr() 
  UI.pads = {}
  UI.oct_vbs  = {}
  UI.len_vbs  = {}
  UI.note_vbs = {}  
  UI.chrd_key_vbs   = {}
  UI.chrd_form_vbs  = {}
  UI.chrd_form_tonnetz_vbs  = {}
  UI.chrd_scale_vbs = {} 
              
  if MW.phr.editor_pattern then
    if MW.phr.editor_poly then
      if MW.phr.editor_pattern_N then
        populatePatPolyN() 
      else
        populatePatPoly()
      end          
    else -- mono
      if MW.phr.editor_pattern_N then
        populatePatN()
      else
        populatePat() 
      end      
    end
  elseif MW.phr.editor_chords then
    if MW.phr.editor_name == 'Tonnetz' then
      initTonnetzFormsMtb()
      populateTonnetz()
    else 
      populateVboxChrd()
    end
  else
    populateVbox()
  end
  
 -- if false and MW.phr.editor_pattern_N then  
   -- local _, pat_len = getPatFun(UI.block_selection)
  --    local last_val = MW.timer_pos2[#MW.timer_pos2]
      
  --    if last_val and pat_len > last_val then
    ---    for i=#MW.timer_pos2+1,pat_len do
   --       MW.timer_pos2[i]=last_val
    --    end 
    --  end
  --end
end


function remove_ln(ln,col)

  local pat_con, pat_len = getPatFun(UI.block_selection)
  
  if ln >= pat_len then
    return
  end   
 
  local pat
  local pat2
  for i=ln+1,pat_len do
    pat = pat_con(i,col)
    pat2 = pat_con(i-1,col)
    
    pat2.note_value = pat.note_value
    pat2.instrument_value = pat.instrument_value
    pat2.volume_value = pat.volume_value
    pat2.panning_value = pat.panning_value
    pat2.delay_value = pat.delay_value
  end     
  
  pat = pat_con(pat_len,col)
  
  pat.note_value = 121
  pat.instrument_value = 255
  pat.volume_value = 255
  pat.panning_value = 255
  pat.delay_value = 255
end


function rowsPatN(ix)

  local pat
  local pat_con = getPatFun(UI.block_selection)

  local ix2 = UI.vel_knob_pos[ix]
  local vel = 0
  
  if ix2 then
    pat = pat_con(ix2, MW.phr.col)
  
    vel = pat.volume_value
    if (vel > 128) then
      vel = 0
    end
  end
  
  local velo_knob = vb:rotary {
    min = 0,
    max = 128,
    value = vel,
    width = 20,
    height = 20,
    notifier = function(value)
      local pat_con = getPatFun(UI.block_selection)
      local pat = pat_con(UI.vel_knob_pos[ix], MW.phr.col)
        
      pat.volume_value = value
    end
    }  
    
  local note_row = vb:row {
    margin  = 2, 
    spacing = 3, 
    velo_knob,    
    UI.editor_rows[ix], 
  }
  return note_row  
end


function add_ln(ln,col)

  local pat_con, pat_len = getPatFun(UI.block_selection)
  
  if ln >= pat_len then
    return
  end   
 
  local pat
  local pat2
  for i=pat_len-1,ln,-1 do
    pat = pat_con(i,col)
    pat2 = pat_con(i+1,col)
    
    pat2.note_value = pat.note_value
    pat2.instrument_value = pat.instrument_value
    pat2.volume_value = pat.volume_value
    pat2.panning_value = pat.panning_value
    pat2.delay_value = pat.delay_value
  end     
  
  pat = pat_con(ln,col)
  
  pat.note_value = 121
  pat.instrument_value = 255
  pat.volume_value = 255
  pat.panning_value = 255
  pat.delay_value = 255
end


function rowsPat(ix)

  local n_col = MW.phr.col
  
  local add = vb:button {
    text = "+",
    tooltip = "Move notes blow, down",
    notifier =  function () 
      if MW.phr.editor_poly then
        for i=1,12 do
          add_ln(ix, i) 
        end 
      else
        add_ln(ix,n_col)         
      end 
      
      updateSlots()        
    end
    }    
  
  local del = vb:button {
    text = "-",
    tooltip = "Move notes blow, up",
    notifier =  function () 
      if MW.phr.editor_poly then
        for i=1,12 do
          remove_ln(ix, i) 
        end 
      else
        remove_ln(ix,n_col)         
      end 
      
      updateSlots()
    end
    }     
 
 
  local cut = vb:button {
    text = "C",
    tooltip = "Note Off",
    notifier =  function () 
      
      local pat_con = getPatFun(UI.block_selection)
      local pat = pat_con(ix, n_col)
      
      if pat.note_value == 120 then         
        pat.note_value = 121
      else
        pat.note_value = 120
      end
      
      updateSlots()
    end
    } 
     
  local pat_con = getPatFun(UI.block_selection)
  local pat = pat_con(ix, n_col)
  
  local vel = pat.volume_value
  if vel > 128 then
    vel = 0
  end
    
  local velo_knob = vb:rotary {
    min = 0,
    max = 128,
    value = vel,
    width = 20,
    height = 20,
    tooltip = "Note Velocity",
    notifier = function(value)
      local pat_con = getPatFun(UI.block_selection)
      local pat = pat_con(ix, n_col)
        
      pat.volume_value = value
    end
    }  
    
  local note_row = vb:row {
    margin  = 2, 
    spacing = 3, 
    add,
    del,
    cut,
    velo_knob,    
    UI.editor_rows[ix], 
  }
  return note_row  
end


function getTx (ix) 
  if #CHptr.notes[ix] == 0 then return '' end
  
  local note,oct = oct0(CHptr.notes[ix][1])
 -- note = CHNptr.note[ix]  
 -- oct  = CHNptr.oct[ix]

  local scale = Scales.forms[UI.chord_scales[ix]] 
  local key   = UI.chord_keys [ix] - 1
   
  scale = scale_key(scale,key)
  note  = noteInScale (note, scale)
  
  return num2note(note + 12 * oct)
end


function rowsVbox(ix) -- mono / poly --------------------------------------------------------------------------

  local note_tx = 
    vb:text {
      width = 30,
      text = getTxVB (ix)
    }    
    
  UI.oct_vbs[ix] =
    vb:valuebox {
      min = 1,
      max = 9,
      width = 42,
      tooltip = "Octave",
      value = Nptr.oct[ix],
      notifier = function(oct)
      
        Nptr.oct[ix] = oct
        note_tx.text = getTxVB (ix) 
        
        local loc = UI.editor_bts[ix].note_ix 
        
        if UI.editor_bts[ix][loc] then  
          UI.editor_bts[ix][loc].color = {1, 1, 1}  
        end
        
        local note =  oct * 12 + Nptr.note[ix]    
        
        loc = UI.editor_bts[ix].notes[note]
        if loc then
          UI.editor_bts[ix][loc].color = {255, 255, 255}           
          UI.editor_bts[ix].note_ix = loc
          
          Nptr.oct[ix] =  oct

          fill(MW.phr.col,{st = ix,en = ix}) 
        end          
      end
    }  

  local note_off_valuebox =
    vb:valuebox {
      min = 0,
      max = 99,
      width = 43,
      tooltip = "Note Off",
      value = Nptr.off[ix],
      notifier = function(value)  
        Nptr.off[ix] = value
        
        if Nptr.len[ix] > 0 then
          fill(MW.phr.col,{st = ix,en = ix, pos = false})
        end
      end
    }  
      
  UI.note_vbs[ix] =
    vb:valuebox {
      min = -12,
      max = 12,
      width = 50,
      tooltip = "Note",
      value = Nptr.note[ix],
      notifier = function(note)

        note_tx.text = getTxVB (ix) 
        
        local loc = UI.editor_bts[ix].note_ix 
        
        if UI.editor_bts[ix][loc] then  
          UI.editor_bts[ix][loc].color = {1, 1, 1}  
        end
        
        local fn = noteInScale(note + Nptr.oct[ix] * 12)  
        
        loc = UI.editor_bts[ix].notes[fn]
        if loc then
          UI.editor_bts[ix][loc].color = {255, 255, 255}           
          UI.editor_bts[ix].note_ix = loc
          
          Nptr.note[ix] = note

          fill(MW.phr.col,{st = ix,en = ix,pos = false})
        end 
      end
    }  

  local len_val = 
    vb:text {
      width = 10,
      text = "" .. Nptr.len[ix]
    }         
 
  UI.len_vbs[ix]  =
    vb:valuebox {
      min = 0,
      max = 999,
      width = 50,
      tooltip = "Note position relative to preceding chord",
      value = Nptr.len[ix],
      notifier = function(value)
      
        len_val.text = "" .. round(value)        
        Nptr.len[ix] = round(value)
        
        
        local note = Nptr.note[ix] + Nptr.oct[ix]  * 12
       
        local loc = UI.editor_bts[ix].notes[note]  
         
        if value == 0 then   
          if loc then
            UI.editor_bts[ix][loc].color = {1, 1, 1}  
          end
            
          UI.editor_bts[ix].note_ix = nil
        elseif loc then
          UI.editor_bts[ix].note_ix = loc
          UI.editor_bts[ix][loc].color = {255, 255, 255} 
        end
       
        fill(MW.phr.col,{st = 1, add_off = true, pos = true})       
      end
    }  
           
    
 local velo_knob = vb:rotary {
    min = 0,
    max = 128,
    value = Nptr.vel[ix],
    width = 20,
    height = 20,
    tooltip = "Note Velocity",
    notifier = function(value)
      Nptr.vel[ix] = round(value)
     -- fill(MW.phr.col,{st = ix,en = ix})
      fillVel(MW.phr.col,Nptr,ix)
    end
  } 
        
  UI.insert_pos_bts[ix] = vb:button {
    tooltip = "Insert note",
    color =  { 1, 1, 1 },
    notifier = function()           
      
      table.insert(Nptr.len, ix, 0)      
      table.insert(Nptr.vel, ix, 0)
      table.insert(Nptr.oct, ix, 0)
      table.insert(Nptr.off, ix, 0)
      table.insert(Nptr.note,ix, 0)
      
      MW.stopTimer()
      
      MW.seq_length  = MW.seq_length + 1  
      
      updateSlots()     
      fill(MW.phr.col, {pos = true})
      
      MW.setTimer()
    end
    }    
   
  local note_row = vb:row {
    margin  = 2, 
    spacing = 3, 
    UI.insert_pos_bts[ix],
    note_tx,
    UI.oct_vbs[ix],
    UI.note_vbs[ix],  
    UI.len_vbs[ix], 
    note_off_valuebox,
    velo_knob,
    UI.editor_rows[ix],
  }
  return note_row
end
  

function rowsVboxChrd(ix)  -- chords / arp --------------------------------------------------------------------------------------
  
  local updateNotes = function () 
      
    local new_key   = UI.chrd_key_vbs  [ix].value 
    local new_oct   = UI.oct_vbs       [ix].value
    local new_form  = Chords.forms[UI.chrd_form_vbs[ix].value]
    local new_note  = UI.note_vbs      [ix].value
    local new_scale = UI.chrd_scale_vbs[ix].value      
        
    local new_chrd_form = map(new_form, function(v) return NearestNfromN_Tb (new_note + new_oct*12, v, Scales.forms[new_scale],new_key-1) end) 
    local notes0 = tbOct0(CHptr.notes[ix])
    
    local tb = {}
    local last_oct
    for k,v in ipairs(new_chrd_form) do
      local ix2, v2 = nearestValue(CHptr.notes[ix], v)
      
      if CHptr.notes[ix][k] then
        last_oct = math.floor(CHptr.notes[ix][k] / 12) 
      end

      tb[k] = clampOct(v%24, last_oct, 1)
    end
    
    CHptr.notes[ix] = tb
        
    each(UI.editor_bts[ix].notes_ix, function(v) UI.editor_bts[ix][v].color = {1, 1, 1} end)
        
    UI.editor_bts[ix].notes_ix = map(CHptr.notes[ix], function(v) return UI.editor_bts[ix].notes[v] end)         
        
    each(UI.editor_bts[ix].notes_ix, function(v) UI.editor_bts[ix][v].color = {255, 255, 255} end)            
  end
  
    
  local tx = getTx (ix)
  
  local note_tx = 
    vb:text {
      width = 30,
      text = tx
    }    
  
  UI.chrd_scale_vbs[ix] = vb:popup {
      width = 125,
      tooltip = "Scale",
      value = UI.chord_scales[ix],
      items = Scales.names,      
      notifier =  function (val) 
        
        if fillVbox.suspend or CHptr.len[ix] == 0 then return end
         
        UI.chord_scales[ix] = val 
        
        updateNotes()
        
        fillVbox.fun({st = ix,en = ix,pos = false})  
      end
    }    

  UI.chrd_key_vbs[ix] = vb:popup {
      width = 45,
      tooltip = "Key",
      value = UI.chord_keys [ix],
      items = Scales.keys,      
      notifier =  function (val)
      
        if fillVbox.suspend or CHptr.len[ix] == 0 then return end
           
        UI.chord_keys [ix] = val  
        
        updateNotes()        
        
        fillVbox.fun({st = ix,en = ix,pos = false}) 
      end
    }   
  
  UI.chrd_form_vbs[ix] = vb:popup {
      width = 90,
      tooltip = "Form",
      value = UI.chord_forms[ix],
      items = Chords.forms_to_str,      
      notifier =  function (val)              
        
        if fillVbox.suspend or CHptr.len[ix] == 0 or val == 24 then return end
        
        UI.chord_forms[ix] = val 
        
        updateNotes()       
        
        local len_ch
        if val == #Chords.forms_to_str then
          len_ch = #CHptr.notes[ix]
        else
          len_ch = #Chords.forms[val]
        end 
        
        UI.arp_note_interval[ix].max = len_ch
        
        if UI.arp_note_interval[ix].value > len_ch then
          UI.arp_note_interval[ix].value = len_ch        
        end
                
        fillVbox.fun({st = ix,en = ix,pos = false})
      end
    }         
  
  local chrd_rand_chb = vb:checkbox {
    value = CHptr.rand[ix],
    tooltip = "Enable randomization",
    notifier = function(value) 
      CHptr.rand[ix] = value
    end
  }
  
  local max_len = #CHptr.notes[ix]
  local note,oct
  if max_len == 0 then
    oct  = 4
    note = 0
    max_len = 1
  else  
    note,oct = oct0(CHptr.notes[ix][1])
  end
        
  UI.oct_vbs[ix] =
    vb:valuebox {
      min = 1,
      max = 9,
      width = 42,
      tooltip = "Oct",
      value = oct,
      notifier = function(oct)            
        
        if fillVbox.suspend or CHptr.len[ix] == 0 then return end
                
        note_tx.text = getTx (ix)
        
        each(UI.editor_bts[ix].notes_ix, function(v) UI.editor_bts[ix][v].color = {1, 1, 1} end)

        CHptr.notes[ix] = map(addToTb(tbOct0(CHptr.notes[ix]), oct*12), function(v) return noteInScale(clamp(v,0,119)) end)
        UI.editor_bts[ix].notes_ix = map(CHptr.notes[ix], function(v) return UI.editor_bts[ix].notes[v] end) 
        
        each(UI.editor_bts[ix].notes_ix, function(v) UI.editor_bts[ix][v].color = {255, 255, 255} end)        

        fillVbox.fun({st = ix,en = ix,pos = false})     
      end
    }  
 
  local val = CHptr.off[ix] 
  
  local note_off_valuebox =
    vb:valuebox {
      min = 0,
      max = 99,
      width = 43,
      tooltip = "Note Off",
      value = val,
      notifier = function(value)  
      
        CHptr.off[ix] = value

        if CHptr.len[ix] > 0 then
          fillVbox.fun({st = ix,en = ix,pos = false})
        end
      end
    }        
      
  UI.note_vbs[ix] =
    vb:valuebox {
      min = -12,
      max = 12,
      width = 50,
      tooltip = "Note / Chord Degree",
      value = note,
      notifier = function(note)

        note_tx.text = getTx (ix)   
        
        if fillVbox.suspend or CHptr.len[ix] == 0 then return end        
                        
        each(UI.editor_bts[ix].notes_ix, function(v) UI.editor_bts[ix][v].color = {1, 1, 1} end) 
        
        local fn   = note + UI.oct_vbs[ix].value  * 12 
           
        local tr = fn - CHptr.notes[ix][1] 
        CHptr.notes[ix] = map(CHptr.notes[ix], function(v) return noteInScale(v + tr) end)     
        UI.editor_bts[ix].notes_ix = map(CHptr.notes[ix], function(v) return UI.editor_bts[ix].notes[v] end) 
        
        each(UI.editor_bts[ix].notes_ix, function(v) UI.editor_bts[ix][v].color = {255, 255, 255} end)         

        fillVbox.fun({st = ix,en = ix,pos = false})   
      end
    }  

  tx = "" .. CHptr.len[ix]
    
  local len_val = 
    vb:text {
      width = 10,
      text = tx
    }         
 
  val = CHptr.len[ix]
  
  UI.len_vbs[ix] =
    vb:valuebox {
      min = 0,
      max = 999,
      width = 50,
      tooltip = "Chord position relative to preceding note",
      value = val,
      notifier = function(value)      
        len_val.text = "" .. value
                
        if fillVbox.suspend then return end 
        
        CHptr.len[ix] = value
        
        local note = CHptr.notes[ix][1]      
        local loc  = UI.editor_bts[ix].notes[note]  

        
        if value == 0 and #UI.editor_bts[ix].notes_ix > 0 then   
          
          each(UI.editor_bts[ix].notes_ix, function(v) UI.editor_bts[ix][v].color = {1, 1, 1} end)   
                       
        elseif #UI.editor_bts[ix].notes_ix > 0 then
          
          each(UI.editor_bts[ix].notes_ix, function(v) UI.editor_bts[ix][v].color = {255, 255, 255} end)                                 
        elseif loc then
          UI.editor_bts[ix][loc].color = {255, 255, 255}  
          UI.editor_bts[ix].notes_ix = {loc}         
           
          UI.chord_keys  [ix] = 1
          UI.chord_forms [ix] = 23    
          UI.chord_scales[ix] = 2  
        end               
   
        fillVbox.fun({st = ix, add_off = true, pos = true})        
      end
    }             
  
  val = CHptr.vel[ix]
      
  local velo_knob = vb:rotary {
    min = 0,
    max = 128,
    value = val,
    width = 20,
    height = 20,
    tooltip = "Note Velocity",
    notifier = function(value)
      CHptr.vel[ix] = round(value) 

      fillVel(MW.phr.col,CHptr,ix)
    end
  } 
        
  UI.insert_pos_bts[ix] = vb:button {
    tooltip = "Insert Chord",
    color =  { 1, 1, 1 },
    notifier = function() 
    
      table.insert(CHptr.len,ix, 0)
      table.insert(CHptr.off,ix, 0)
      table.insert(CHptr.vel,ix, 0)
      table.insert(CHptr.notes,ix, {60})
      
      MW.stopTimer()
    
      MW.seq_length  = MW.seq_length + 1
        
      updateSlots()           
      fillVbox.fun()
      
      MW.setTimer()
    end
    }    
   
  local arp_octave_vb =
    vb:valuebox {
      min = 1,
      max = 4,
      width = 42,
      tooltip = "Arp Octave",
      value = CHptr.arp.oct[ix],
      notifier = function(value)       
        CHptr.arp.oct[ix] = value
        fillVbox.fun({st = ix,en = ix,pos = false})  
     end
  }

  local arp_pres_vb =
    vb:valuebox {
      min = 1,
      max = #Arp.forms,
      width = 42,
      tooltip = "Arp pattern",
      value = CHptr.arp.form[ix],
      notifier = function(value)       
        CHptr.arp.form[ix] = value
        fillVbox.fun({st = ix,en = ix,pos = false})  
     end
  }
  
  local arp_rand_chb = vb:checkbox {
    value = CHptr.arp.rand[ix],
    tooltip = "Arp pattern and octave randomization",
    notifier = function(value) 
      CHptr.arp.rand[ix] = value
    end
  }  

  UI.arp_note_interval[ix] = vb:valuebox {
    min = 1,
    max = max_len,
    value = CHptr.arp.off[ix],
    tooltip = "Chord note to start with",
    notifier = function(value) 
      CHptr.arp.off[ix] = value
      fillVbox.fun({st = ix,en = ix,pos = false, pos = false})  
    end
  } 
           
  local note_row = vb:row {
    margin  = 2, 
    spacing = 3, 
  }

  
  note_row:add_child(UI.insert_pos_bts[ix])
  note_row:add_child(note_tx)
  note_row:add_child(UI.oct_vbs[ix])
  note_row:add_child(UI.note_vbs[ix])
  note_row:add_child(UI.chrd_scale_vbs[ix])
  note_row:add_child(UI.chrd_key_vbs[ix])
  note_row:add_child(UI.chrd_form_vbs[ix])
  note_row:add_child(UI.len_vbs[ix])
  note_row:add_child(note_off_valuebox)
  note_row:add_child(velo_knob)
  note_row:add_child(chrd_rand_chb)
     
  if MW.phr.editor_name == "Arpeggiator" then
    note_row:add_child(arp_octave_vb) 
    note_row:add_child(arp_pres_vb)
    note_row:add_child(UI.arp_note_interval[ix]) 
    note_row:add_child(arp_rand_chb) 
  end
  
  note_row:add_child(UI.editor_rows[ix])
  
  return note_row
end


function rowsTonnetz2(ix) 

  local updateNotes = function () 
      
    each(UI.editor_bts[ix].notes_pos, function(v) UI.editor_bts[ix].tonnetz[v.y][v.x].color = {1,1,1} end)   
    UI.editor_bts[ix].notes_pos = {}
          
    local new_key   = UI.chrd_key_vbs  [ix].value 
    local new_oct   = UI.oct_vbs       [ix].value
    local new_form  = Chords.forms[UI.chrd_form_vbs[ix].value]
    local new_note  = UI.note_vbs      [ix].value
    local new_scale = UI.chrd_scale_vbs[ix].value      
        
    local new_chrd_form = map(new_form, function(v) return NearestNfromN_Tb (new_note + new_oct*12, v, Scales.forms[new_scale],new_key-1) end) 
    local notes0 = tbOct0(CHptr.notes[ix])
    
    local tb = {}
    local last_oct
    for k,v in ipairs(new_chrd_form) do
      local ix2, v2 = nearestValue(CHptr.notes[ix], v)
      
      if CHptr.notes[ix][k] then
        last_oct = math.floor(CHptr.notes[ix][k] / 12) 
      end

      tb[k] = clampOct(v%24, last_oct, 1)
    end
    
    CHptr.notes[ix] = tb       
    
    getTonnetzNotes(ix)     
  end
    
  local tx = getTx (ix)
  
  local note_tx = 
    vb:text {
      width = 30,
      text = tx
    }    
  
  UI.chrd_scale_vbs[ix] = vb:popup {
      width = 125,
      tooltip = "Scale",
      value = UI.chord_scales[ix],
      items = Scales.names,      
      notifier =  function (val) 
        UI.chord_scales[ix] = val 
        
        if fillVbox.suspend then return end
        
        updateNotes()   
        
        fillVbox.fun({st = ix,en = ix,pos = false})  
      end
    }    

  UI.chrd_key_vbs[ix] = vb:popup {
      width = 45,
      tooltip = "Key",
      value = UI.chord_keys [ix],
      items = Scales.keys,      
      notifier =  function (val)   
        UI.chord_keys [ix] = val  
        
        if fillVbox.suspend then return end
           
        updateNotes()   
        
        fillVbox.fun({st = ix,en = ix,pos = false}) 
      end
    }   
  
  UI.chrd_form_vbs[ix] = vb:popup {
    width = 90,
    tooltip = "Form",
    value = UI.chord_forms[ix],
    items = Chords.forms_to_str,      
    notifier =  function (val)  
      UI.chord_forms[ix] = val 
        
      if fillVbox.suspend then return end
        
      local len_ch
      if val == #Chords.forms_to_str then
        len_ch = #CHptr.notes[ix]
      else
        len_ch = #Chords.forms[val]
      end
        
      if UI.arp_note_interval[ix].value > len_ch then
        UI.arp_note_interval[ix].value = len_ch        
      end
        
      UI.arp_note_interval[ix].max = len_ch
        
      updateNotes()       
                
      fillVbox.fun({st = ix,en = ix,pos = false})
    end
  }         

    
  local newChord = function(chrd_ix)  
    
    local s = Tonnetz.chord 
    local sel_ix = Tonnetz.chords_ix[s] 
    
    if chrd_ix == 12 or sel_ix == chrd_ix then return end

    local sort = Tonnetz.adj[s][chrd_ix].sort 
    
    if #UI.editor_bts[ix].notes_pos > 1 then
      if sort == '<y' then    
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.y < b.y end) 
      
      elseif sort == '>y' then    
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.y > b.y end)
      
      elseif sort == '<x' then    
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.x < b.x end)
      
      elseif sort == '<x<y' then
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.x < b.x end)  
      
        local x = UI.editor_bts[ix].notes_pos[1].x
      
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.y < b.y and a.x == x and b.x == x end)
      
      elseif sort == '<y<x' then
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.y < b.y end)  
      
        local y = UI.editor_bts[ix].notes_pos[1].y
      
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.x < b.x and a.y == y and b.y == y end)  
    
      elseif sort == '<x>y' then
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.x < b.x end)  
      
        local x = UI.editor_bts[ix].notes_pos[1].x
      
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.y > b.y and a.x == x and b.x == x end)
      
      elseif sort == '<y>x' then
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.y < b.y end)  
      
        local y = UI.editor_bts[ix].notes_pos[1].y
      
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.x > b.x and a.y == y and b.y == y end)  
      
      elseif sort == '>x<y' then
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.x > b.x end)  
      
        local x = UI.editor_bts[ix].notes_pos[1].x
      
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.y < b.y and a.x == x and b.x == x end)
      
      elseif sort == '>y<x' then
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.y > b.y end)  
      
        local y = UI.editor_bts[ix].notes_pos[1].y
      
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.x < b.x and a.y == y and b.y == y end)  
    
      elseif sort == '>x>y' then
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.x > b.x end)  
      
        local x = UI.editor_bts[ix].notes_pos[1].x
      
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.y > b.y and a.x == x and b.x == x end)
      
      elseif sort == '>y>x' then
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.y > b.y end)  
      
        local y = UI.editor_bts[ix].notes_pos[1].y
      
        table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.x > b.x and a.y == y and b.y == y end)             
      
      elseif sort == 'avg' then
        local x_tb = map(UI.editor_bts[ix].notes_pos, function(v) return v.x end)
        local y_tb = map(UI.editor_bts[ix].notes_pos, function(v) return v.y end)
      
        local mean_x = mean(x_tb) 
        local mean_y = mean(y_tb)

        UI.editor_bts[ix].notes_pos[1].x = round(mean_x)
        UI.editor_bts[ix].notes_pos[1].y = round(mean_y)
      end
    end
         
    local x1   = UI.editor_bts[ix].notes_pos[1].x
    local y1   = UI.editor_bts[ix].notes_pos[1].y
    local oct1 = UI.editor_bts[ix].notes_pos[1].oct
    
      
    local tb = {} 
          
    for k,v in ipairs(Tonnetz.adj[s][chrd_ix]) do
      local new_x = x1 + v.x
      local new_y = y1 + v.y
            
      if y1 % 2 == 0 then
        new_x = new_x + v.even
      else
        new_x = new_x + v.odd
      end      
      
      local nbt_tb = {x     = new_x, 
                      y     = new_y, 
                      oct   = oct1, 
                      note  = nil,
                      pad_x = pad_x_max/2, 
                      pad_y = pad_y_max/2}                      
      
    
      if Tonnetz.adj[s][chrd_ix].add == false then      
        tb[k] =  nbt_tb                     
      else
        table.insert(UI.editor_bts[ix].notes_pos , nbt_tb)
      end   
    end            
    
    if Tonnetz.adj[s][chrd_ix].add == false then              
      UI.editor_bts[ix].notes_pos = tb
    end        
  end

 
  local checkAdjust = function() 
    local lowest_y = 1
    local highest_y = 6
    
    local lowest_x  = {}
    local highest_x = {}
    
    local lowest_x_ix 
    local highest_x_ix 
    
    for k,v in ipairs(UI.editor_bts[ix].notes_pos)  do
      
      if lowest_x[v.oct] == nil then
        lowest_x[v.oct]  = {}  
      end
      
       if highest_x[v.oct] == nil then  
        highest_x[v.oct] = {}
      end
      
      if v.y < lowest_y  then lowest_y  = v.y end
      if v.y > highest_y then highest_y = v.y end
      
      if v.x < v.oct*12  then 
        lowest_x_ix = k
        lowest_x[v.oct]  = v.x 
      end
      
      if v.x > v.oct*12 + 11  then 
        highest_x_ix = k
        highest_x[v.oct] = v.x 
      end      
    end    

    if lowest_y < 1 then
      local adj = 1 - lowest_y 
 
      for k,v in ipairs(UI.editor_bts[ix].notes_pos)  do
        v.y = v.y + adj 
        
        if v.y % 2 == 0 then
          v.x = v.x - 1                        
        end
          
        v.note = Tonnetz.oct1[v.y][v.x % 12] + (math.floor(v.x/12) + UI.oct_st.value)*12 
      end
    end

    if highest_y > 6 then
      local adj = highest_y - 6 
      
      for k,v in ipairs(UI.editor_bts[ix].notes_pos)  do
        v.y = v.y - adj 
        
        if v.y % 2 == 0 then
          v.x = v.x - 1                        
        end
                       
        v.note = Tonnetz.oct1[v.y][v.x % 12] + (math.floor(v.x/12) + UI.oct_st.value)*12         
      end
    end 
     
    if lowest_x_ix then     
      
      local ix2 = lowest_x_ix
      local oct = UI.editor_bts[ix].notes_pos[ix2].oct    
      
      local adj = (UI.editor_bts[ix].notes_pos[ix2].oct*12) - lowest_x[oct]    
      
      for k,v in ipairs(UI.editor_bts[ix].notes_pos)  do
        v.x = v.x + adj
        v.note = Tonnetz.oct1[v.y][v.x % 12] + (math.floor(v.x/12) + UI.oct_st.value)*12 
      end
    end
    
    if highest_x_ix then    
      
      local ix2 = highest_x_ix
      local oct = UI.editor_bts[ix].notes_pos[ix2].oct   
     
      local adj = highest_x[oct] - (UI.editor_bts[ix].notes_pos[ix2].oct*12+11) 
    
      for k,v in ipairs(UI.editor_bts[ix].notes_pos)  do
        v.x = v.x - adj
        v.note = Tonnetz.oct1[v.y][v.x % 12] + (math.floor(v.x/12) + UI.oct_st.value)*12 
      end
    end 
  end
  
  local updateChordNotes = function()
    CHptr.notes[ix] = {}
    
    for k,v in ipairs(UI.editor_bts[ix].notes_pos)  do
        
      if v.note == nil then          
        local new_note = Tonnetz.oct1[v.y][v.x % 12] + (math.floor(v.x/12) + UI.oct_st.value)*12
        
        v.note = new_note
      end
      
      if UI.tonnetz_force_sk_chb[ix].value and UI.scales_pu.value > 1 then 
        CHptr.notes[ix][k] = noteInScaleForce(v.note) 
      else 
        CHptr.notes[ix][k] = v.note 
      end  
    end
    
    if UI.tonnetz_force_sk_chb[ix].value and UI.scales_pu.value > 1 then 
      getTonnetzNotes(ix) 
    end
    
    table.sort(CHptr.notes[ix])
    
    seekChd(CHptr.notes[ix],ix)   
     
    local note,oct = oct0(CHptr.notes[ix][1])                  
    
    fillVbox.suspend = true
    
    UI.oct_vbs[ix].value   = oct         
    UI.note_vbs[ix].value  = note
                       
    UI.chrd_key_vbs[ix].value   = UI.chord_keys [ix]
    UI.chrd_form_vbs[ix].value  = UI.chord_forms[ix]
    UI.chrd_scale_vbs[ix].value = UI.chord_scales[ix] 
  
    fillVbox.suspend = false
  end
  
  UI.chrd_form_tonnetz_vbs[ix] = vb:popup {
    width = 105,
    tooltip = "Tonnetz shape that ROUGHLY corresponds to listed chord forms",
    value = UI.form_tonnetz[ix],
    items = Tonnetz.chords_names,      
    notifier =  function (val) 
            
      if #UI.editor_bts[ix].notes_pos == 0 or Tonnetz.suspend or val == 12 then return end      
            
      each(UI.editor_bts[ix].notes_pos, function(v) UI.editor_bts[ix].tonnetz[v.y][v.x].color = {1,1,1} end)

      newChord(val)    
      checkAdjust()      
      updateChordNotes()
   
      each(UI.editor_bts[ix].notes_pos, function(v) UI.editor_bts[ix].tonnetz[v.y][v.x].color = {255,255,255} end)           
       
      UI.form_tonnetz[ix] = val        
       
      Tonnetz.chord = Tonnetz.chords_names[val] 
                
      fillVbox.fun({st = ix,en = ix,pos = false})
    end
  }    
  
  local chrd_rand_chb = vb:checkbox {
    value = CHptr.rand[ix],
    tooltip = "Enable randomization",
    notifier = function(value) 
      CHptr.rand[ix] = value
    end
  }
  
  local note,oct
  if #CHptr.notes[ix] == 0 then
    oct  = 4
    note = 0
  else  
    note,oct = oct0(CHptr.notes[ix][1])
  end
          
  UI.oct_vbs[ix] =
    vb:valuebox {
      min = 1,
      max = 9,
      width = 42,
      tooltip = "Oct",
      value = oct,
      notifier = function(oct)            
                
        note_tx.text = getTx (ix)
        
        if fillVbox.suspend or CHptr.len[ix] == 0 then return end

        each(UI.editor_bts[ix].notes_pos, function(v) UI.editor_bts[ix].tonnetz[v.y][v.x].color = {1,1,1} end)   
        UI.editor_bts[ix].notes_pos = {}
        
        CHptr.notes[ix] = map(addToTb(tbOct0(CHptr.notes[ix]), oct*12), function(v) return noteInScale(clamp(v,0,119)) end)
               
        getTonnetzNotes(ix) 

        fillVbox.fun({st = ix,en = ix,pos = false})     
      end
    }  
   
  local note_off_valuebox =
    vb:valuebox {
      min = 0,
      max = 99,
      width = 43,
      tooltip = "Note Off",
      value = note,
      notifier = function(value)  
      
        CHptr.off[ix] = value

        if CHptr.len[ix] > 0 then
          fillVbox.fun({st = ix,en = ix,pos = false})
        end
      end
    }        
   
  UI.note_vbs[ix] =
    vb:valuebox {
      min = -12,
      max = 12,
      width = 50,
      tooltip = "Note / Chord Degree",
      value = note,
      notifier = function(note)

        note_tx.text = getTx (ix)   
        
        if fillVbox.suspend or CHptr.len[ix] == 0 then return end        
                
        each(UI.editor_bts[ix].notes_pos, function(v) UI.editor_bts[ix].tonnetz[v.y][v.x].color = {1,1,1} end)   
        UI.editor_bts[ix].notes_pos = {}
        
        local fn   = note + UI.oct_vbs[ix].value  * 12 
           
        local tr = fn - CHptr.notes[ix][1] 
        CHptr.notes[ix] = map(CHptr.notes[ix], function(v) return noteInScale(v + tr) end)         
                      
        getTonnetzNotes(ix)
        
        fillVbox.fun({st = ix,en = ix,pos = false})   
      end
    }  
  
  tx = "" .. CHptr.len[ix]
    
  local len_val = 
    vb:text {
      width = 10,
      text = tx
    }         
  
  UI.len_vbs[ix] =
    vb:valuebox {
      min = 0,
      max = 999,
      width = 50,
      tooltip = "Chord position relative to preceding note",
      value = CHptr.len[ix],
      notifier = function(value)      
        len_val.text = "" .. round(value)
                
        if fillVbox.suspend then return end
        
        CHptr.len[ix] = round(value)
        
        local note =   UI.note_vbs[ix].value + UI.oct_vbs[ix].value * 12      
        
        if value == 0 and #UI.editor_bts[ix].notes_pos > 0 then
       
          each(UI.editor_bts[ix].notes_pos, function (v) UI.editor_bts[ix].tonnetz[v.y][v.x].color = {1, 1, 1}  end)
                 
        elseif #UI.editor_bts[ix].notes_pos > 0 then 
       
          each(UI.editor_bts[ix].notes_pos, function (v) UI.editor_bts[ix].tonnetz[v.y][v.x].color = {255, 255, 255}  end)
          
        else 
          UI.chord_keys  [ix] = 1
          UI.chord_forms [ix] = 23    
          UI.chord_scales[ix] = 2  
          
          getTonnetzNotes(ix)        
        end
                        
        fillVbox.fun({st = ix, add_off = true, pos = true})        
      end
    }           
        
  local velo_knob = vb:rotary {
    min = 0,
    max = 128,
    value = CHptr.vel[ix],
    width = 20,
    height = 20,
    tooltip = "Note Velocity",
    notifier = function(value)
      CHptr.vel[ix] = round(value) 

      fillVel(MW.phr.col,CHptr,ix)
    end
  } 
        
  UI.insert_pos_bts[ix] = vb:button {
    tooltip = "Insert Chord",
    color =  { 1, 1, 1 },
    notifier = function() 
    
      table.insert(CHptr.len,ix, 0)
      table.insert(CHptr.off,ix, 0)
      table.insert(CHptr.vel,ix, 0)
      table.insert(CHptr.notes,ix, {60})
      
      MW.stopTimer()
    
      MW.seq_length  = MW.seq_length + 1
    
      updateSlots()
      fillVbox.fun()
      
      MW.setTimer()
    end
  }       
  
  local random_but2 = vb:button {
    text = ' R2 ',
    tooltip = 'Random chord shape',
    notifier =  function ()
      UI.chrd_form_tonnetz_vbs[ix].value = math.random(1,11)
    end
  }
  
  UI.tonnetz_force_sk_chb[ix] = vb:checkbox { 
    value = false,
    tooltip = "Force scale and key",
  }    
           
  local force_sk = vb:row{
    style = 'group',
    vb:text{
      text = 'SK',
    },
    UI.tonnetz_force_sk_chb[ix],
  }          
         
  Tonnetz.random1 = function(ix)       

      local clear = function()
       for k,v in pairs(UI.editor_bts[ix].notes_pos) do  
         UI.editor_bts[ix].tonnetz[v.y][v.x].color = {1, 1, 1}  
       end
       
      CHptr.notes[ix] = {}
        UI.editor_bts[ix].notes_pos = {}        
      end
      
      local oct             
      local octs = UI.oct_end.value - UI.oct_st.value  
     
      if #UI.editor_bts[ix].notes_pos == 0 then 
        
        if ix > 2 and #UI.editor_bts[ix-1].notes_pos > 0 then
          oct = UI.editor_bts[ix-1].notes_pos[1].oct   
        else
          oct = round((octs-1)/2)
        end      
        
        CHptr.len[ix] = UI.len_vbs[ix].value
         
      elseif #UI.editor_bts[ix].notes_pos == 1 then  
        
        oct = UI.editor_bts[ix].notes_pos[1].oct   
        
      elseif #UI.editor_bts[ix].notes_pos > 1 then
      
        local x_tb = map(UI.editor_bts[ix].notes_pos, function(v) return v.x end)
        local y_tb = map(UI.editor_bts[ix].notes_pos, function(v) return v.y end)
      
        local mean_x = mean(x_tb)
        local mean_y = mean(y_tb)
      
        oct = math.floor(mean_x / 12)  
      end
      
      if oct then  
        local random_ch = math.random(1,11) 
        
        local rand_x = math.random(0,11)  
        local rand_y = math.random(1,5)  
      
        clear()
        
        local new_note = Tonnetz.oct1[rand_y][rand_x % 12] + oct*12
        CHptr.notes[ix] = {new_note}
              
        UI.editor_bts[ix].notes_pos[1] = {x = rand_x + oct*12, 
                                          y = rand_y, 
                                          oct = oct, 
                                          note = new_note,     
                                          pad_x = pad_x_max/2, 
                                          pad_y = pad_y_max/2}      
                                          
        UI.editor_bts[ix].tonnetz[rand_y][rand_x + oct*12].color = {255,255,255}
        
        Tonnetz.suspend = true
        UI.chrd_form_tonnetz_vbs[ix].value = 12                    
        Tonnetz.chord   = 'Other'      
        
        Tonnetz.suspend = false

        UI.chrd_form_tonnetz_vbs[ix].value = random_ch 
      end     
       
  end
  
           
  local random_but = vb:button {
    text = ' R1 ',
    tooltip = 'Random x,y and chord shape',
    notifier =  function ()
      Tonnetz.random1(ix)
    end 
  }
           
  local note_row = vb:row {
    margin  = 2, 
    spacing = 3, 
  }
  
  note_row:add_child(UI.insert_pos_bts[ix])
  note_row:add_child(note_tx)
  note_row:add_child(UI.oct_vbs[ix])
  note_row:add_child(UI.note_vbs[ix])
  note_row:add_child(UI.chrd_scale_vbs[ix])
  note_row:add_child(UI.chrd_key_vbs[ix])
  note_row:add_child(UI.chrd_form_vbs[ix])
  note_row:add_child(UI.chrd_form_tonnetz_vbs[ix])
  note_row:add_child(UI.len_vbs[ix])
  note_row:add_child(note_off_valuebox)
  note_row:add_child(velo_knob)
  note_row:add_child(force_sk)
  note_row:add_child(random_but)
  note_row:add_child(random_but2)
  note_row:add_child(chrd_rand_chb)
       
  if MW.phr.editor_name == "Arpeggiator" then
    note_row:add_child(arp_octave_vb) 
    note_row:add_child(arp_pres_vb)
    note_row:add_child(UI.arp_note_interval[ix]) 
    note_row:add_child(arp_rand_chb) 
  end
  
  findTonnetzChord(ix) 
  
  return note_row
end


function getTxVB (ix)
  local note
  note = noteInScale(Nptr.note[ix])
  return num2note(note + 12 * Nptr.oct[ix])
end


function rowsTonnetz (ix)

  UI.insert_pos_bts[ix] = vb:button {
    tooltip = "Insert Chord",
    color =  { 1, 1, 1 },
    notifier = function()        
      
      local ch_len_tb2      = copy(CHptr.len)
      local ch_velo_tb2     = copy(CHptr.vel)      
      local ch_note_off_tb2 = copy(CHptr.off)
      
      for i=ix+1,#Nptr.note-1 do 
        CHptr.off[i] = ch_note_off_tb2[i-1]
        CHptr.len[i] = ch_len_tb2[i-1]
        CHptr.vel[i] = ch_velo_tb2[i-1]
      end

      CHptr.off[ix] = 0
      CHptr.len[ix] = 0
      CHptr.vel[ix] = 127  
      
      MW.stopTimer()
    
      MW.seq_length  = MW.seq_length + 1

      updateSlots()       
      fillVbox.fun()
      
      MW.setTimer()
    end
    }    
    
  local note_tx = 
    vb:text {
      width = 30,
      text = tostring(ix),
    }  
    
  UI.pads[ix] = vb:xypad {
    min      = {x=0,y=0},
    max      = {x = pad_x_max,   y = pad_y_max},
    value    = {x = pad_x_max/2, y = pad_y_max/2},
    notifier = function (val)   
        
      local new_notes = {}      
      local xy_bkp = {}

      for k,v in pairs(UI.editor_bts[ix].notes_pos) do
        local pad_x_dif = round(val.x) - v.pad_x   
        local pad_y_dif = round(val.y) - v.pad_y 
        
        if pad_x_dif ~= 0 or pad_y_dif ~= 0 then
          UI.editor_bts[ix].tonnetz[v.y][v.x].color = {1,1,1}  
        end        
        
        xy_bkp[k] = {x = v.x, y = v.y}
      end        
      
      table.sort(UI.editor_bts[ix].notes_pos, function(a,b) return a.y < b.y end)
        
      for k,v in pairs(UI.editor_bts[ix].notes_pos) do
        
        local pad_x_dif = round(val.x) - v.pad_x 
        local pad_y_dif = round(val.y) - v.pad_y 
      
        if pad_x_dif ~= 0 or pad_y_dif ~= 0 then           
           
          local cond1 = v.y  == 2 and v.y - pad_y_dif == 3   
          local cond2 = v.y  == 4 and v.y - pad_y_dif == 5  
           
          if cond1 or cond2 then  
            v.x = v.x + 1                        
          end
           
          cond1 = v.y  == 5 and v.y - pad_y_dif == 4      
          cond2 = v.y  == 3 and v.y - pad_y_dif == 2  
          
          if cond1 or cond2 then
            v.x = v.x - 1                        
          end
           
          local lower_oct = v.oct*12   
          local higer_oct = v.oct*12 + 11 

          --local new_x = clampAround2(v.x + pad_x_dif, lower_oct, higer_oct)  
          --local new_y = clampAround (v.y - pad_y_dif, 1, 6)
   
          local new_x = v.x + pad_x_dif  
          local new_y = v.y - pad_y_dif   
                  
          if new_y < 1 or new_y > 6 or new_x < lower_oct or new_x > higer_oct then 
            new_x = xy_bkp[k].x
            new_y = xy_bkp[k].y
          end
          
          local new_note  = Tonnetz.oct1[new_y][new_x % 12] + (math.floor(new_x/12) + UI.oct_st.value)*12 
          
          local new_x2, new_y2 = new_x, new_y
          
          local exists, key = member(new_note,new_notes) 
          while exists and k ~= key do 
            
            sprint('Duplicate note, using random x,y (-1 to 1) location insted')
            
            new_x2 = new_x + math.random(-1,1)  
            new_y2 = new_y + math.random(-1,1)
           
            if new_y2 < 1 or new_y2 > 6 or new_x2 < lower_oct or new_x2 > higer_oct then
              
              exists = true
              
            else
              new_note  = Tonnetz.oct1[new_y2][new_x2 % 12] + (math.floor(new_x2/12) + UI.oct_st.value)*12 
            
              exists, key = member(new_note,new_notes)              
            end
          end
                    
          new_x = new_x2  
          new_y = new_y2  
           
          UI.editor_bts[ix].tonnetz[new_y][new_x].color = {255,255,255}
          v.x   = new_x
          v.y   = new_y          
          v.oct =  math.floor(new_x/12)        
          
          new_note  = Tonnetz.oct1[v.y][v.x % 12] + (v.oct + UI.oct_st.value)*12          
          v.note    = new_note
                    
          table.insert(new_notes, new_note)   
          
          v.pad_x = round(val.x)
          v.pad_y = round(val.y)
        end
      end
      
      if #new_notes > 0 then
        
          CHptr.notes[ix] = new_notes
              
          for k,v in pairs(UI.editor_bts[ix].notes_pos) do
            UI.editor_bts[ix].tonnetz[v.y][v.x].color = {255,255,255}    
          end
          
          fillVbox.suspend = true 

          table.sort(new_notes)
          seekChd(new_notes,ix)  
          
          local note,oct = oct0(new_notes[1])  

          CHptr.len [ix] = UI.len_vbs[ix].value   

          UI.oct_vbs[ix].value   = oct         
          UI.note_vbs[ix].value  = note
                   
          UI.chrd_key_vbs[ix].value   = UI.chord_keys [ix]
          UI.chrd_form_vbs[ix].value  = UI.chord_forms[ix]
          UI.chrd_scale_vbs[ix].value = UI.chord_scales[ix]  
          
          findTonnetzChord(ix)
          
          table.sort(CHptr.notes[ix])
    
          seekChd(CHptr.notes[ix],ix)   
     
          local note,oct = oct0(CHptr.notes[ix][1])            

          fillVbox.suspend = false 
          fillVbox.fun({st = ix,en = ix,pos = false})                     
      end
    end
  }  
  
  local note_row = vb:column {
   style = 'group',
   margin = 3,
      
     vb:row{   
       UI.pads[ix],
       UI.editor_rows[ix],
     },
     
     rowsTonnetz2(ix),
      
  }
  return note_row
end
  

function editorRows(ix)
  
  if MW.phr.editor_chords then    
    if MW.phr.editor_name == 'Tonnetz' then
      return rowsTonnetz(ix)
    else
      return rowsVboxChrd(ix)
    end
  elseif MW.phr.editor_pattern then     
    if MW.phr.editor_pattern_N then    
      return rowsPatN(ix)
    else  
      return rowsPat(ix)
    end
  else 
    return rowsVbox(ix)
  end
end  
  
  
updateSlots = function () 
  
  if UI.suspend_update then return end  
  UI.suspend_update = true
       
     
  if UI.DT.value then
    dialog_content3:remove_child(UI.editor_main)
  else
    dialog_content:remove_child(UI.editor_main)
  end    
  UI.editor_main = vb:column {style = "group"}
    
    
  local st = MW.seq_start
  local en = MW.seq_length  
    
  UI.slots_st.value  = MW.seq_start
  UI.slots_end.value = MW.seq_length    
    
  if MW.phr.editor_chords then      
    local grow_by_n = #CHptr.notes - en  
    if grow_by_n < 0 then 
      for i=1,math.abs(grow_by_n) do
        Chords.grow(CHptr)
      end
    end
  else 
    local grow_by_n = #Nptr.note - en   
    if grow_by_n < 0 then 
      for i=1,math.abs(grow_by_n) do
        Notes.grow(Nptr)
      end
    end
  end
  
  populate_pr()  
  
  for i=st, en do  
    UI.editor_main:add_child(editorRows(i)) 
  end
  
  if UI.DT.value then
    dialog_content3:add_child(UI.editor_main)
  else
    dialog_content:add_child(UI.editor_main)
  end  
  
  UI.suspend_update = false
end    
  
