local all_chords = {}


function seekChd(tb,j)  print('------------------ Chords.forms ') rprint(Chords.forms) print('tb') rprint(tb)  print('tbOct0all(tb)') rprint(tbOct0all(tb))
  local chrd = getChFromNodes(Scan.chords_tb_oct0, tbOct0all(tb), 1)  
  
  if chrd then   print('chrd ') rprint(chrd)
    UI.chord_keys[j]   = chrd.key
    UI.chord_scales[j] = chrd.scale
    UI.chord_forms [j] = chrd.form        
  else 
    UI.chord_keys[j]   = 1
    UI.chord_scales[j] = 1  
    UI.chord_forms [j] = #Chords.forms       
  end
end


local function seekChd2(tb,j)  

  sprint('Looking up chord: ' .. j)
  
  local norm_note, norm_oct = oct0(tb[1]) 
  
  tb = tbOct0all(tb)
  
  for k=2,#Scales.forms do
    for l=1,12 do 
      for m=1,#Chords.forms do      
        
        local chrd = getChrd (norm_note, k, l, Chords.forms[m]) 
        if  tableComp (tb,chrd) then 
          
          UI.chord_scales[j]  = k
          UI.chord_keys [j] = l
          UI.chord_forms[j] = m
                            
          Nptr.note[j] = norm_note
          Nptr.oct[j] = norm_oct                 
          return             
        end 
      end
    end        
  end  
  
  UI.chord_keys  [j] = 1
  UI.chord_forms [j] = 1
  UI.chord_scales[j] = 1
  
  Nptr.oct [j] = norm_oct
  Nptr.note[j] = norm_note   
end

function grabNotes()  

  UI.suspend_update = true
  Scan.Markov_process = nil
  
  all_chords = {}
  local lastNoteTb = {}
      
  local ph  = MW.phr.no
  local col = MW.phr.col        
  
  local tr       = renoise.song().selected_track_index  
  local pattern  = curPattern ()
  MW.phr.pat_len = renoise.song().selected_pattern.number_of_lines   
   
  
  if (#pattern:track(tr).lines[1].note_columns == 0) then
    return
  end
  
  if MW.phr.editor_chords then   ---------------------------

    all_chords        = {}
    MW.phr[ph].chords = Chords.new(0)   
    
    assignChordTbs()   
    
    lastNoteTb[1], MW.timer_pos = GrebSeq(col, true, CHptr) 
        
    UI.oct_st.value  = Nptr.oct_lowest
    UI.oct_end.value = Nptr.oct_highest+1
    
    if #CHptr.notes < MW.seq_length and #CHptr.notes > 0 then
      MW.seq_length = #CHptr.notes
    end       
    
    duplicateChordNotes()
    
    UI.oct_st.value  = CHptr.oct_lowest
    UI.oct_end.value = CHptr.oct_highest+1
    

    if MW.harmonize_typ == 2 then 
      if MW.phr.event_type == 1 then
        assignNoteTbs(MW.phr.col)
            
        harmonizeP2Ch ()            
  
        phraseScanner()
        fillPtr(MW.phr.col, Nptr, 1) 
      elseif MW.phr.event_type == 2 then
             
      end
            
      if MW.harmonize_fill_chrd then
        fillPtr(MW.phr.col, Nptr, 1) 
              
        fillPtr(MW.phr.col, CHptr, 3, {track = MW.harmonize_track, inst = MW.harmonize_inst})
      end
                   
    else  
      if MW.harmonize_typ == 3 then    
        harmonizeCh2P(ScannerChordH())
      end
      
      duplicateChordNotes() 
      fill(col)
    end

  elseif MW.phr.editor_poly then  -----------------------------

    local oct_lowest, oct_highest = 8,2
    
    for i=12,1,-1 do  
      MW.timer_poly_pos[i] = {}
      POLYptr[i] = Notes.new(0)          
      
      assignNoteTbs(i)
      
      lastNoteTb[i], MW.timer_poly_pos[i] = GrebSeq(i, false, POLYptr[i]) 
                 
      if Nptr.oct_lowest < oct_lowest then
        oct_lowest = Nptr.oct_lowest
      end
      
      if Nptr.oct_highest > oct_highest then
        oct_highest = Nptr.oct_highest
      end    
      
      if MW.harmonize_typ == 2 then 
        harmonizeP2Ch()   
      end
      
      duplicatePoly()      
      fill(i)
    end     
    
    if MW.harmonize_typ == 3 then      
      harmonizeCh2P(ScannerH())      
    end
      
    assignNoteTbs(col)
    
    UI.oct_st.value  = oct_lowest  
    UI.oct_end.value = oct_highest+1   
    
    if #Nptr.note < MW.seq_length and #Nptr.note > 0 then
      MW.seq_length = #Nptr.note
      UI.slots_end.value = MW.seq_length   
    end   
    
  else -------------------------------------- mono

    MW.phr[ph].notes[col] = Notes.new(0) 
    
    assignNoteTbs(col)
    
    lastNoteTb[1], MW.timer_pos = GrebSeq(col, false,  Nptr)         
    
    UI.oct_st.value  = Nptr.oct_lowest
    UI.oct_end.value = Nptr.oct_highest+1
    
    if #Nptr.note < MW.seq_length and #Nptr.note > 0 then
      MW.seq_length = #Nptr.note
    end
    
    if MW.harmonize_typ == 2 then 
      harmonizeP2Ch()   
    elseif MW.harmonize_typ == 3 then      
      harmonizeCh2P(ScannerH())       
    end
    
    duplicateNotes()
    
    fill(col)
  end   
    
   
  if WeightedIntervals.lock == 1 then
    duplicateNotesRand()
    WeightedIntervals.new = true
  end    
   
  MW.seq_start = 1 -- UI.slots_st.value = 1

  phraseScanner()    
  findScaleKeyUpdatePopup()  
  
  UI.suspend_update = false  
  updateSlots()
end


function grabPatPos(tb) 
  local res = {}
  
  for k,v in ipairs(tb) do
    for i=v.line,v.line + v.alen-1 do
      res[i] = k
    end     
  end    
  return res
end 


function grabConvert(chords, src, dst)   
  local oct_lowest, oct_highest = 8,2
  
  if #src == 0 then return {} end
  
  local dst_len = #src
  
  if chords then 
    Chords.newPtr(dst, dst_len) 
  else
    Notes.newPtr(dst, dst_len)
  end  
  
  dst.len[1]  = src[1].line  
  dst.pat_len = src.pat_len   
  
  for k,v in ipairs(src) do 
        
    local note,oct    

    if chords then 
      table.sort(v.note)
      v.note = unique(v.note) 
      v.note = map(v.note, function(v) return noteInScale(v) end)    
       
      tableConcat(all_chords, v.note) 
          
      seekChd(v.note,k)
      
      oct = math.floor(math.min(unpack(v.note)) / 12)  
      
      if oct < oct_lowest then
        oct_lowest = oct
      end
      
      oct = math.floor(math.max(unpack(v.note)) / 12)  
      if oct > oct_highest then
        oct_highest = oct
      end
      
      dst.notes[k] = v.note 
    else
      note,oct = oct0(v.note)
          
      dst.oct [k] = oct
      dst.note[k] = noteInScale(note) 
      
      if oct < oct_lowest then
        oct_lowest = oct
      end
    
      if oct > oct_highest then
        oct_highest = oct
      end 
    end

    dst.vel [k]   = v.vel   
    dst.off [k]   = v.off    
    dst.alen[k]   = v.alen 
    if k < #src then
      dst.len [k+1] = clamp(v.alen, MW.grab_min_len, MW.grab_max_len)
    end  
    
    dst.line[k]   = v.line 
  end 
 
  dst.oct_lowest, dst.oct_highest = oct_lowest, oct_highest
end 


function grabColBasicFun(n_col,fun,arg) 

  local pat_con, pat_len, st = fun(unpack(arg)) 
  if UI.block_selection then st = st + 1 end
  
  local res = {}    
  
    for ln = st, pat_len do
      local n_col_tb = {}
        local notes_found, off_found, pat, fn, volume 
        
        if not MW.phr.editor_chords then      
          pat = pat_con(ln, n_col)
          fn = pat.note_value
          volume = clamp(pat.volume_value,0,128)
          
          notes_found = fn < 120 
          off_found = fn == 120
        else  --chord 
          fn = {} 
          for i=1,12 do
            pat = pat_con(ln, i)
            if pat.note_value < 120 then
              table.insert(fn,pat.note_value)
              
              if volume == nil then
                volume = clamp(pat.volume_value,0,128)
              end
            end
          end
          
          notes_found = #fn > 0
          
          pat = pat_con(ln, n_col)
          off_found = pat.note_value == 120
        end
        
        if notes_found then  
          table.insert(res, {note = fn, line = ln, alen = ln, off = 0, vel = volume }) 
          
          if #res>1 then   
            local alen = res[#res].alen - res[#res-1].alen   
            res[#res-1].alen = alen    
          end
        elseif #res == 0 and off_found then
          res.pattern_starts_with_note_off = ln  
        elseif #res > 0 and off_found then  
          res[#res].off = ln - res[#res].line    
        end        
    end
    
    if #res > 0 then
      res[#res].alen = pat_len - res[#res].alen + 1        
    end  
    
    res.pat_len = pat_len 
  return res    
end


function grabColBasic(n_col)
  return grabColBasicFun(n_col,getPatFun,{UI.block_selection})
end


function grabColBasicTr(n_col,pat_ix,tr)
  return grabColBasicFun(n_col,getPatFun,{UI.block_selection,pat_ix,tr})
end


function GrebSeq(n_col, chords, dest)
 
  local seq, pos_tb = {},{}
  
  if MW.grab_seq then   
    local song = renoise.song()

    local song_len = #song.sequencer.pattern_sequence 
    local patterns = song.sequencer.pattern_sequence 

    local range = renoise.song().sequencer.selection_range 
     
    if range[1] > 0 then          
      for i=range[1],range[2] do
        table.insert(seq, grabColBasicFun(n_col,getPatFun,{UI.block_selection,patterns[i]}))
      end     
      
      local first_note = true
      local prev_pat_last_note      
      if #seq>1 then  
        local add_lines = 0
        
        for i=2,#seq do               
          add_lines = add_lines + seq[i-1].pat_len 
          for k,v in ipairs(seq[i]) do
            v.line = v.line + add_lines
          end  
        end 
        
        local merged_pats = {}
        local merged_pat_len = 0
          
        for k,v in ipairs(seq) do
          merged_pat_len = merged_pat_len + v.pat_len 
          
          for _,vv in ipairs(v) do
            table.insert(merged_pats, vv) 
            
            local ix = #merged_pats
            if ix > 1 then
              merged_pats[ix-1].alen = merged_pats[ix].line - merged_pats[ix-1].line            
            end
          end
        end  
        
        merged_pats.pat_len = merged_pat_len
           
        grabConvert(chords, merged_pats, dest)     
        pos_tb = grabPatPos(merged_pats)  
        return #merged_pats, pos_tb  
      else       
        grabConvert(chords, seq[1],dest)     
        pos_tb = grabPatPos(seq[1])
        return #seq[1], pos_tb
      end
      
    else
      sprint('Range empty')
      return 0,{}
    end
  else 
    seq = grabColBasic(n_col) 
    grabConvert(chords, seq,dest)  
    pos_tb = grabPatPos(seq)
    
    return #seq, pos_tb
  end   
  
  return 0, {}
end


