Load = {}
Save = {}

local function getScanTranspose(phr_type) 

  if Scan.scale_key_on then   -- lenTb(Scan.db_scale_key[phr_type])>0 and
    local sca = UI.scales_pu.value
    local key = UI.keys_pu.value
    
    local ix = UI.lib_pu.value 
    return Scan.db_scale_key[phr_type][sca][key].transpose[ix]     
  end 
end


local function getPatLen(ptr) 
  if ptr.pat_len then
    return ptr.pat_len
  else
    return renoise.song().selected_pattern.number_of_lines   
  end 
end


Load.notes = function(fn, ...)
  local str = ''
  
  local msg = {}
  msg.tr   = true   
  msg.pos  = true
  msg.load = true
  
  local load = {}
  load.phr  = Lib.editor == 2
  load.step = Lib.editor == 1 and MW.phr.event_type == 1
  load.poly = Lib.editor == 1 and MW.phr.event_type == 2
  load.chrd = Lib.editor == 1 and MW.phr.event_type == 3
  
  if arg[1] then
    msg = arg[1]
  end
  
  if arg[2] then
    load = arg[2]
  end
  
  if fileExists(fn) then
    if msg.load then str = 'Loading ' .. fn end

    local content = readFile(fn)
    local fun     = loadstring(content)             
    
      
    if load.phr  then
      MW.phr = fun()   
    elseif load.step then  --------------------- step mono
      local tb = fun()  
            
      Nptr.fn   = tb.fn 
      Nptr.off  = tb.off       
      Nptr.oct  = tb.oct   
      Nptr.len  = tb.len 
      Nptr.vel  = tb.vel
      Nptr.alen = tb.alen    
      Nptr.note = tb.note 
      Nptr.line = tb.line 
      
      Nptr.pat_len = tb.pat_len 
      
      Nptr.oct_lowest  = tb.oct_lowest
      Nptr.oct_highest = tb.oct_highest
      
      if Nptr.pat_len == nil then  -------------------------------------- delete later 
        Nptr.pat_len = getPatLen(Nptr) 
      end
      renoise.song().selected_pattern.number_of_lines = Nptr.pat_len
      
      if msg.pos then
        local line = 0
        for _,len in ipairs(Nptr.len) do
          line = line + len
        end  
        str = str .. '  |  ' .. 'Last note pattern position ' .. line .. '  |  ' .. 'pattern length ' .. Nptr.pat_len
      end
      
      local transpose = getScanTranspose('mono')
      
      if transpose then        
        if msg.tr then str = str .. '  |  ' .. 'Transpose mono phrase by ' .. transpose end
        
        for k,note in ipairs(Nptr.note) do 
                  
          note = clamp(note +  Nptr.oct[k] * 12 + transpose, 0, 119)
          
          local nn, oct = oct0(note)
          
          Nptr.oct[k]  = oct
          Nptr.note[k] = nn                      
        end
      end 
      
    elseif load.chrd then  ---------------------------------------------- chords
      local tb = fun()  
      
      tableMakeEqualLen(tb.len, tb.notes)
      
      CHptr.arp.oct  = tb.arp.oct     
      CHptr.arp.off  = tb.arp.off
      CHptr.arp.form = tb.arp.form    
      CHptr.arp.rand = tb.arp.rand
    
      CHptr.len   = tb.len 
      CHptr.vel   = tb.vel
      CHptr.off   = tb.off 
      CHptr.rand  = tb.rand
      CHptr.line  = tb.line
      CHptr.notes = tb.notes  
      
      CHptr.pat_len = tb.pat_len             
      
      CHptr.oct_lowest  = tb.oct_lowest
      CHptr.oct_highest = tb.oct_highest

      if CHptr.pat_len == nil then  -------------------------------------- delete later 
        CHptr.pat_len = getPatLen(CHptr) 
      end      
      
      renoise.song().selected_pattern.number_of_lines = CHptr.pat_len
      
      if msg.pos then
        local line = 0
        for _,len in ipairs(CHptr.len) do
          line = line + len
        end  
        str = str .. '  |  ' .. 'Last note pattern position ' .. line .. '  |  ' .. 'pattern length ' .. CHptr.pat_len
      end
      
      local transpose = getScanTranspose('chrd')
      
      if transpose then        
        if msg.tr then str = str .. '  |  ' .. 'Transpose chord notes by ' .. transpose end
        
        for k,notes in ipairs(CHptr.notes) do
          CHptr.notes[k] = map(notes, function(v) local note, oct = oct0(v) return clamp((v+transpose)%12 + oct*12,0,119) end)
        end
      end
      
    elseif load.poly then ------------------------------------------------ poly
    
      local phr = MW.phr.no       
      local tb  = fun()
      
      for i=1,12 do        
        MW.phr[phr].notes[i].fn   = tb[i].fn 
        MW.phr[phr].notes[i].off  = tb[i].off       
        MW.phr[phr].notes[i].oct  = tb[i].oct   
        MW.phr[phr].notes[i].len  = tb[i].len 
        MW.phr[phr].notes[i].vel  = tb[i].vel
        MW.phr[phr].notes[i].alen = tb[i].alen    
        MW.phr[phr].notes[i].note = tb[i].note 
        MW.phr[phr].notes[i].line = tb[i].line
         
        MW.phr[phr].notes[i].pat_len = tb[i].pat_len 
        
        MW.phr[phr].notes[i].oct_lowest  = tb[i].oct_lowest
        MW.phr[phr].notes[i].oct_highest = tb[i].oct_highest
      end
      
      for _,note_col in ipairs(MW.phr[phr].notes) do      ------------------------------ delete later
        local pat_len = getPatLen(note_col) 
        
        if note_col.pat_len == nil then  
          note_col.pat_len = pat_len 
        end
      end
      
      renoise.song().selected_pattern.number_of_lines = MW.phr[phr].notes[1].pat_len
      
      if msg.pos then
        local lines = {0,0,0,0,0,0,0,0,0,0,0,0}
        
          for i=1,12 do
            for _,len in ipairs(MW.phr[phr].notes[i].len) do
              lines[i] = lines[i] + len
            end  
          end
          
        local max_line = math.max(unpack(lines))  
        str = str .. '  |  ' .. 'Last note pattern position ' .. max_line .. '  |  ' .. 'pattern length ' ..  MW.phr[phr].notes[1].pat_len
      end
      
      local transpose = getScanTranspose('poly')
      
      if transpose then               
        if msg.tr then str = str .. '  |  ' ..  'Transpose poly phrase by ' .. transpose end
        
        for _,note_col in ipairs(MW.phr[phr].notes) do
        
          for k,note in ipairs(note_col.note) do 
                    
            note = clamp(note +  note_col.oct[k] * 12 + transpose, 0, 119)
          
            local nn, oct = oct0(note)
          
            note_col.oct[k]  = oct
            note_col.note[k] = nn                      
          end 
        end
      end     
    end
    
    sprint(str)   
  else
    sprint(fn .. ' Not found !')  
  end 
end


Load.notesPtr = function (fn, event_type)  
  
  fn = MW.path .. fn  
  
  if fileExists(fn) then
    sprint('Processing ' .. fn)
       
    local content = readFile(fn)
    local fun     = loadstring(content)    
    local ptr     = fun() 
       
    if event_type == 'mono' then   
    
      return {ptr.note}, {ptr.off}, {ptr.len}, getPatLen(ptr)        
   
    elseif event_type == 'poly' then ---------------------------------------------   
      local notes,offs,lens = {},{},{}
       
      for _,v in ipairs(ptr) do
        table.insert(offs,  v.off) 
        table.insert(lens,  v.len)         
        table.insert(notes, v.note) 
      end 
         
      return notes, offs, lens, getPatLen(ptr[1])         
      
    elseif event_type == 'chrd' then   ------------------------------------------
    
      return ptr.notes, ptr.off, ptr.len, getPatLen(ptr)  
    end

  else
    return nil,nil,nil  
  end 
end


Save.notes = function(fn)

  if fileExists(fn) then
    os.remove (fn)   
  end 
        
  local file = io.open(fn, "wb") 
  sprint('Saving ' .. fn)
  
  if Lib.editor == 2 then
    file:write('return ' .. serialize(MW.phr))
  elseif Lib.editor == 1 then     
    if MW.phr.editor_pattern and MW.phr.editor_poly == false then
      file:write('return ' .. serialize(Nptr))  
    elseif MW.phr.editor_chords then  
      file:write('return ' .. serialize(CHptr))
    elseif MW.phr.editor_poly then  
      file:write('return ' .. serialize(MW.phr[MW.phr.no].notes))
    end    
  end
       
  file:close()   
end


local function lenTb (tb)
  
  if tb == nil then return 0 end
  
  local i = 0
  local tb_ret = {}
  for v in pairs(tb) do
    i=i+1
    table.insert(tb_ret, v)
  end
  return i, tb_ret
end 
   

function getFilesRemExt()
  if Lib.editor == 2 then
    return remExt(os.filenames(MW.path, {"*" .. '.phr'}))
  elseif Lib.editor == 1 then
    return remExt(os.filenames(MW.path, {"*" .. Lib.file_ext}))
  end
end


function getFiles(ext)
  return os.filenames(MW.path, {"*" .. ext})
end


function getArpFiles()
  Arp.files_full = os.filenames(MW.path, {"*" .. ".arp"})
  Arp.files = remExtEnd(Arp.files_full)
end


function readFile(fn)
  if fileExists(fn) then
     
    local file = io.open(fn, "rb") 
    local content = file:read "*a"
    file:close()
    
    return content
  end 
end


function writeArpForms (name)  

  local num  
  local file = io.open(name, "wb")   
  
  for i=1,#Arp.forms do
  
    for j=1,#Arp.forms[i] do  
    
      num = Arp.forms[i][j]
      
      if (num < 0) then 
        num = num + 256
      end  
      
      file:write(string.char(num))      
    end
        
    file:write(",")
        
    for j=1,#Arp.skip_note_tb[i] do  
      local char = "f"
      if Arp.skip_note_tb[i][j] then
        char = "t"
      end
      
      file:write(char)      
    end
    
    file:write(",")    
    
    num = Arp.directions[i]
    file:write(string.char(num))        
       
    
    if (i < #Arp.forms) then
      file:write(",")
    end
  end    

  file:close()
end


function readArpForms (name)  

  if (fileExists(name)) then

    local file = io.open(name, "rb") 
    local content = file:read "*a"
    file:close()
    
    Arp.forms = {}
    Arp.skip_note_tb = {}
    Arp.directions = {}
         
    local j=1
    local tb = {}
    tb[1] = {}
    for i=1,#content,1 do
      local char = string.sub(content,i,i)   
      
      if (char == ",") then
        j = j + 1
        tb [j] = {}
      else
        tb [j] [#tb[j]+1] = char
      end   
    end      
    
    local k=1
    for i=1,#tb,3 do
      Arp.forms[k]  = {}
      Arp.skip_note_tb[k]  = {}
      Arp.directions[k]  = {}
      
      for j=1,#tb[i] do
      
        local num = string.byte(tb[i][j])
        local char = tb[i+1][j]
        
        if (num > 128) then 
          num = num - 256
        end  
                    
        Arp.forms[k] [#Arp.forms[k]+1] = num
        
        if (char == "t") then
          Arp.skip_note_tb[k] [#Arp.skip_note_tb[k]+1] = true
        else
          Arp.skip_note_tb[k] [#Arp.skip_note_tb[k]+1] = false
        end 
        
        if (j==1) then
          Arp.directions[k] = string.byte(tb[i+2][j])          
        end                
      end
      k=k+1
    end 
    UI.arp_pres_vb.max = #Arp.forms    
    
    UI.arp_form = 1
    UI.arp_pres_vb.value = 1
  end  
end


